// Copyright (C) 2008 Seiji Tamura
//
// ̃\[X̓pubNhCƂČJĂ
// JavaScriptPL/0(쐬 ۍ_ 2008/01/24)b
// ڐÂłB
//
// ̂bŃ\[X̒쌠͍(c)ێ
// ܂A҂ւ̘AȂɎRɉςĎgpĒ
// Ė肠܂Bςۂɂ͏L̒쌠\
// OĂgpB
// (@\ǉėVԈʂg͂܂...)
//
// Œ蒷zgĂӏӏ̂ŊS
// ڐAɂ͂ȂĂȂłB
// IWiJSŃ\[XƕׂČׂĂ݂ƁA
// قƂǉl̂܂ܖbɈڐA
// ƂĂ܂̂ł͂ȂƎv܂B
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define IDENT        1
#define NUMBER       2

#define R_PROGRAM    3
#define R_PROCEDURE  4
#define R_BEGIN      5
#define R_END        6
#define R_VAR        7
#define R_CALL       8
#define R_IF         9
#define R_THEN       10
#define R_WHILE      11
#define R_DO         12
#define R_ODD        18
#define R_PRINT      19

#define SEMICOLON    20
#define COMMA        21
#define PERIOD       22
#define LPAREN       23
#define RPAREN       24

#define OP_BECOMES   30
#define OP_ADD       31
#define OP_MUL       32
#define OP_COMP      33

typedef struct stKeywords {
	char *key;
	int val;
}	keywords_t;

keywords_t keytbl[] = {
	{"begin",       R_BEGIN     },
	{"end",         R_END       },
	{"program",     R_PROGRAM   },
	{"procedure",   R_PROCEDURE },
	{"var",         R_VAR       },
	{"if",          R_IF        },
	{"then",        R_THEN      },
	{"while",       R_WHILE     },
	{"do",          R_DO        },
	{"call",        R_CALL      },
	{"odd",         R_ODD       },
	{"print",       R_PRINT     }
};
int keytbl_cnt = sizeof(keytbl) / sizeof(keytbl[0]);

int keywords(char *key)
{
	int i;
	for (i = 0; i < keytbl_cnt; i++) {
		if (strcmp(key, keytbl[i].key) == 0) {
			return(keytbl[i].val);
		}
	}
	return(0);
}

#define F_LIT  1
#define F_OPR  2
#define F_LOD  3
#define F_STO  4
#define F_CAL  5
#define F_INT  6
#define F_JMP  7
#define F_JPC  8

char *codeName[] = {"NOP","LIT","OPR","LOD","STO","CAL","INT","JMP","JPC"};

#define V_LES  1
#define V_GTR  2
#define V_EQL  3
#define V_NEQ  4
#define V_LEQ  5
#define V_GEQ  6
#define V_ADD  7
#define V_SUB  8
#define V_MUL  9
#define V_DIV  10
#define V_RET  11
#define V_PRT  12
#define V_ODD  13
#define V_NEG  14

char *opName[] = {"","<",">","=","<>","<=",">=","+","-","*","/","ret","print","odd","-"};

typedef struct stOptable {
	char *key;
	int val;
}	optable_t;

optable_t optbl[] = {
	{"<",       V_LES },
	{">",       V_GTR },
	{"=",       V_EQL },
	{"<>",      V_NEQ },
	{"<=",      V_LEQ },
	{">=",      V_GEQ },
	{"+",       V_ADD },
	{"-",       V_SUB },
	{"*",       V_MUL },
	{"/",       V_DIV }
};
int optbl_cnt = sizeof(optbl) / sizeof(optbl[0]);

int optable(char *key)
{
	int i;
	for (i = 0; i < optbl_cnt; i++) {
		if (strcmp(key, optbl[i].key) == 0) {
			return(optbl[i].val);
		}
	}
	return(0);
}

#define K_VARIABLE   1
#define K_PROCEDURE  2
#define K_CONST      3

#define OTHERS  98
#define EOFILE  99

typedef struct stPTable {
	char *key;
	int len;
	int val;
}	pTable_t;

pTable_t pTable[] = {
	{":=",  2,  OP_BECOMES },
	{">=",  2,  OP_COMP    },
	{"<=",  2,  OP_COMP    },
	{"=",   1,  OP_COMP    },
	{">",   1,  OP_COMP    },
	{"<",   1,  OP_COMP    },
	{"+",   1,  OP_ADD     },
	{"-",   1,  OP_ADD     },
	{"*",   1,  OP_MUL     },
	{"/",   1,  OP_MUL     },
	{";",   1,  SEMICOLON  },
	{",",   1,  COMMA      },
	{".",   1,  PERIOD     },
	{"(",   1,  LPAREN     },
	{")",   1,  RPAREN     },
	{".",   1,  OTHERS     }, // XXXX
	{"\0",  1,  EOFILE     }  // XXXX
};
int pTable_cnt = sizeof(pTable) / sizeof(pTable[0]);

pTable_t eof_ptn = {"\0", 0, EOFILE};

pTable_t *chkToken(char *src)
{
	int i;
	if ((*src) == '\0') {
		return(&eof_ptn);
	}
	for (i = 0; i < pTable_cnt; i++) {
		if (strncmp(src, pTable[i].key, pTable[i].len) == 0) {
			return(&pTable[i]);
		}
	}
	return(NULL);
}

typedef struct stTokenizer {
	char *src;
	int token;
//	char *value;
	char value[256];
	int (*getToken)(struct stTokenizer *);
}	Tokenizer;

int getToken(Tokenizer *this);

Tokenizer *new_Tokenizer(char *s)
{
	// CX^X̐ƃtB[hϐ̃Zbg
	Tokenizer *this = malloc(sizeof(Tokenizer));
	this->src = s;
	this->token = 0;
//	this->value = "";
	memset(this->value, 0, sizeof(this->value));
	// ֐|C^̓o^
	this->getToken = getToken;
	// IɊmۂԂĂ̂Œ
	return(this);
}

void delete_Tokenizer(Tokenizer *this)
{
	if (this) {
		free(this);
	}
}

int isBlank(int c)
{
	if (c == ' ' || c == '\t' || c == '\r' || c == '\n') {
		return(1);
	}
	return(0);
}

int chkSepa(int c)
{
	char *sepa = " \t\r\n:=><+-*/;,.()";
	int tmp;
	int pos = 0;
	while (tmp = sepa[pos++]) {
		if (tmp == c) {
			return(1);
		}
	}
	return(0);
}

int getToken(Tokenizer *this)
{
	int kword;
	pTable_t *ptn;
	while (isBlank(*(this->src))) {
		this->src++;
	}
	this->token = 0;
	memset(this->value, 0, sizeof(this->value));
	if (*(this->src) >= '0' && *(this->src) <= '9') {
		int n, c;
		n = *(this->src) - '0';
		while ((c = *(++(this->src))) >= '0' && c <= '9') {
			n = n * 10 + c - '0';
		}
		this->token = NUMBER;
		sprintf(this->value, "%d", n);
	}
	else if ((ptn = chkToken(this->src)) != NULL) {
		this->token = ptn->val;
		strcpy(this->value, ptn->key);
		this->src += ptn->len;
	}
	else {
		int pos = 0;
		this->token = IDENT;
		while (chkSepa(*(this->src)) == 0) {
			this->value[pos++] = *(this->src);
			this->src++;
		}
	}
	kword = keywords(this->value);
	if (this->token == IDENT && kword) {
		this->token = kword;
	}
	return(this->token);
}

typedef struct stIdentifier {
	char *name;
	int addr;
	int kind;
	int level;
}	Identifier;

Identifier *new_Identifier(char *name, int addr, int kind, int level)
{
	// CX^X̐ƃtB[hϐ̃Zbg
	Identifier *this = malloc(sizeof(Identifier));
	this->name = malloc(strlen(name) + 1);
	strcpy(this->name, name);
	this->addr = addr;
	this->kind = kind;
	this->level = level;
	// ֐|C^̓o^
	// IɊmۂԂĂ̂Œ
	return(this);
}

void delete_Identifier(Identifier *this)
{
	if (this) {
		if (this->name) {
			free(this->name);
		}
		free(this);
	}
}

typedef struct stPCode {
	int func;
	int level;
	int addr;
}	PCode;

PCode *new_PCode(int f, int L, int a)
{
	// CX^X̐ƃtB[hϐ̃Zbg
	PCode *this = malloc(sizeof(PCode));
	this->func  = f;			// function code
	this->level = L;			// block level
	this->addr  = a;			// displacement address
	// ֐|C^̓o^
	// IɊmۂԂĂ̂Œ
	return(this);
}

void delete_PCode(PCode *this)
{
	if (this) {
		free(this);
	}
}

typedef struct stVM {
	int codeAlloc;
	PCode *code[5000];
	int (*gen)(struct stVM *, int, int, int);
	void (*interprete)(struct stVM *);
	void (*dump)(struct stVM *);
	void (*backPatch)(struct stVM *, int);
	int (*currentCx)(struct stVM *);
}	VM;

int gen(VM *this, int op, int level, int addr);
void interprete(VM *this);
void dump(VM *this);
void backPatch(VM *this, int x);
int currentCx(VM *this);

VM *new_VM()
{
	// CX^X̐ƃtB[hϐ̃Zbg
	VM *this = malloc(sizeof(VM));
	this->codeAlloc = 0;
//XXXX	this->code = [];			// Instruction Code table
	// ֐|C^̓o^
	this->gen = gen;
	this->interprete = interprete;
	this->dump = dump;
	this->backPatch = backPatch;
	this->currentCx = currentCx;
	// IɊmۂԂĂ̂Œ
	return(this);
}

void delete_VM(VM *this) //XXXX
{
	int i;
	if (this) {
		for (i = 0; i < this->codeAlloc; i++) {
			delete_PCode(this->code[i]);
		}
		free(this);
	}
}

int gen(VM *this, int op, int level, int addr)
{
	int cp = this->codeAlloc++;
	this->code[cp] = new_PCode(op, level, addr);
	return(cp);
}

// static link ǂ
int base(int bp, int level, int *stack)
{
	int b1;
	for (b1 = bp; level > 0; level--) {
		b1 = stack[b1];
	}
	return(b1);
}

void interprete(VM *this)
{
	int sp = 0;				// stack pointer
	int bp = 1;				// base pointer
	int pc = 0;				// program counter
	int stack[2048]; // = [0, 0, 0, 0];
	memset(stack, 0, sizeof(stack));
	printf("*** START PL/0 ***\n");
	do {
		PCode *pcode = this->code[pc++];
		switch (pcode->func) {
		case F_LIT:
			stack[++sp] = pcode->addr;
			break;
		case F_OPR:
			switch(pcode->addr) {
			case V_NEG: stack[sp] = -stack[sp]; break;
			case V_ODD: stack[sp] &= 1; break;
			case V_ADD: sp--; stack[sp] += stack[sp + 1]; break;
			case V_SUB: sp--; stack[sp] -= stack[sp + 1]; break;
			case V_MUL: sp--; stack[sp] *= stack[sp + 1]; break;
			case V_DIV: sp--; stack[sp] /= stack[sp + 1]; break;
			case V_LES: sp--; stack[sp] = stack[sp] < stack[sp + 1]; break;
			case V_GTR: sp--; stack[sp] = stack[sp] > stack[sp + 1]; break;
			case V_EQL: sp--; stack[sp] = stack[sp] == stack[sp + 1]; break;
			case V_NEQ: sp--; stack[sp] = stack[sp] != stack[sp + 1]; break;
			case V_LEQ: sp--; stack[sp] = stack[sp] <= stack[sp + 1]; break;
			case V_GEQ: sp--; stack[sp] = stack[sp] >= stack[sp + 1]; break;
			case V_PRT: printf("%d\n", stack[sp--]); break; //XXXX
			case V_RET:
				sp = bp - 1;
				pc = stack[sp + 3];
				bp = stack[sp + 2];
				break;
			default:
				printf("interpret-1\n");
				exit(-1);
				break;
			}
			break;
		case F_LOD:
			stack[++sp] = stack[base(bp, pcode->level, stack) + pcode->addr];
			break;
		case F_STO:
			stack[base(bp, pcode->level, stack) + pcode->addr] = stack[sp--];
			break;
		case F_CAL:
			stack[sp + 1] = base(bp, pcode->level, stack);
			stack[sp + 2] = bp;
			stack[sp + 3] = pc;
			bp = sp + 1;
			pc = pcode->addr;
			break;
		case F_INT:
			sp += pcode->addr;
			break;
		case F_JMP:
			pc = pcode->addr;
			break;
		case F_JPC:
			if (stack[sp--] == 0) {
				pc = pcode->addr;
			}
			break;
		default:
			printf("interpret-2\n");
			exit(-1);
			break;
		}
	} while (pc != 0);
	printf("***  END PL/0  ***\n");
}

void dump(VM *this)
{
	int i;
	for (i = 0; i < this->codeAlloc; i++) {
		if (this->code[i]->func == F_OPR) {
			printf("%d:%s\t%s\n",
			       i,
			       codeName[this->code[i]->func],
			       opName[this->code[i]->addr]);
		}
		else {
			printf("%d:%s\t%d:%d\n",
			       i,
			       codeName[this->code[i]->func],
			       this->code[i]->level,
			       this->code[i]->addr);
		}
	}
}

void backPatch(VM *this, int x)
{
	this->code[x]->addr = this->codeAlloc;
}

int currentCx(VM *this)
{
	return(this->codeAlloc);
}

typedef struct stTable {
	char name[256];
	Identifier *p;
}	Table;

typedef struct stScope {
	struct stScope *parent;
	Table table[50];
	int tcount;
	int level;
	int dataAlloc;
	void (*setTable)(struct stScope *, char *, Identifier *);
	Identifier *(*getTable)(struct stScope *, char *);
	Identifier *(*add)(struct stScope *, char *, int, int);
	Identifier *(*addVariable)(struct stScope *, char *);
	Identifier *(*addProcedure)(struct stScope *, char *);
	struct stScope *(*push)(struct stScope *);
	struct stScope *(*pop)(struct stScope *this);
	Identifier *(*search)(struct stScope *, char *);
}	Scope;

void setTable(Scope *this, char *name, Identifier *p);
Identifier *getTable(Scope *this, char *name);
Identifier *add(Scope *this, char *name, int addr, int kind);
Identifier *addVariable(Scope *this, char *name);
Identifier *addProcedure(Scope *this, char *name);
Scope *push(Scope *this);
Scope *pop(Scope *this);
Identifier *search(Scope *this, char *name);

Scope *new_Scope(Scope *parent, int level)
{
	// CX^X̐ƃtB[hϐ̃Zbg
	Scope *this = malloc(sizeof(Scope));
	this->parent = parent;
	memset(this->table, 0, sizeof(this->table));
	this->tcount = 0;
	this->level = level;
	this->dataAlloc = 3;
	// ֐|C^̓o^
	this->setTable = setTable;
	this->getTable = getTable;
	this->add = add;
	this->addVariable = addVariable;
	this->addProcedure = addProcedure;
	this->push = push;
	this->pop = pop;
	this->search = search;
	// IɊmۂԂĂ̂Œ
	return(this);
}

void delete_Scope(Scope *this)
{
	int i;
	if (this) {
		for (i = 0; i < this->tcount; i++) {
			delete_Identifier(this->table[i].p);
		}
		free(this);
	}
}

void setTable(Scope *this, char *name, Identifier *p)
{
	strcpy(this->table[this->tcount].name, name);
	this->table[this->tcount].p = p;
	this->tcount++;
}

Identifier *getTable(Scope *this, char *name)
{
	int i;
	for (i = 0; i < this->tcount; i++) {
		if (strcmp(this->table[i].name, name) == 0) {
			return(this->table[i].p);
		}
	}
	return(NULL);
}

Identifier *add(Scope *this, char *name, int addr, int kind)
{
	Identifier *p = new_Identifier(name, addr, kind, this->level);
	this->setTable(this, name, p);
	return(p);
}

Identifier *addVariable(Scope *this, char *name)
{
	return(this->add(this, name, this->dataAlloc++, K_VARIABLE));
}

Identifier *addProcedure(Scope *this, char *name)
{
	return(this->add(this, name, 0, K_PROCEDURE));
}

Scope *push(Scope *this)
{
	Scope *newScope = new_Scope(this, this->level + 1);
	return(newScope);
}

Scope *pop(Scope *this)
{
	Scope *parent = this->parent;
	delete_Scope(this);
	return(parent);
}

Identifier *search(Scope *this, char *name)
{
	Identifier *p = this->getTable(this, name);
	if (p) {
		return(p);
	}
	else if (this->parent == NULL) {
		return(NULL);
	}
	else {
		return(this->parent->search(this->parent, name));
	}
}

typedef struct stParser {
	Tokenizer *tokenizer;
	Scope *scope;
	VM *vm;
	void (*syntaxError)(struct stParser *, char *);
	void (*check)(struct stParser *, int);
	void (*variableList)(struct stParser *);
	void (*procedure)(struct stParser *);
	void (*procedureList)(struct stParser *);
	void (*statementList)(struct stParser *);
	void (*factor)(struct stParser *);
	void (*term)(struct stParser *);
	void (*expression)(struct stParser *);
	void (*condition)(struct stParser *);
	void (*assignStatement)(struct stParser *);
	void (*callProcedure)(struct stParser *);
	void (*ifStatement)(struct stParser *);
	void (*whileStatement)(struct stParser *);
	void (*statement)(struct stParser *);
	void (*block)(struct stParser *, Identifier *);
	void (*parse)(struct stParser *);
}	Parser;

void syntaxError(Parser *this, char *s);
void check(Parser *this, int t);
void variableList(Parser *this);
void procedure(Parser *this);
void procedureList(Parser *this);
void statementList(Parser *this);
void factor(Parser *this);
void term(Parser *this);
void expression(Parser *this);
void condition(Parser *this);
void assignStatement(Parser *this);
void callProcedure(Parser *this);
void ifStatement(Parser *this);
void whileStatement(Parser *this);
void statement(Parser *this);
void block(Parser *this, Identifier *p);
void parse(Parser *this);

Parser *new_Parser(char *s, VM *vm)
{
	// CX^X̐ƃtB[hϐ̃Zbg
	Parser *this = malloc(sizeof(Parser));
	this->tokenizer = new_Tokenizer(s);
	this->scope = new_Scope(NULL, 0);
	this->vm = vm;
	// ֐|C^̓o^
	this->syntaxError = syntaxError;
	this->check = check;
	this->variableList = variableList;
	this->procedure = procedure;
	this->procedureList = procedureList;
	this->statementList = statementList;
	this->factor = factor;
	this->term = term;
	this->expression = expression;
	this->condition = condition;
	this->assignStatement = assignStatement;
	this->callProcedure = callProcedure;
	this->ifStatement = ifStatement;
	this->whileStatement = whileStatement;
	this->statement = statement;
	this->block = block;
	this->parse = parse;
	// IɊmۂԂĂ̂Œ
	return(this);
}

void delete_Parser(Parser *this) //XXXX
{
	if (this) {
		if (this->tokenizer) {
			delete_Tokenizer(this->tokenizer);
		}
		if (this->scope) {
			delete_Scope(this->scope);
		}
		free(this);
	}
}

void syntaxError(Parser *this, char *s)
{
	printf("syntax error: %s %s\n", s, this->tokenizer->src);
	exit(-1);
}

void check(Parser *this, int t)
{
	if (t == this->tokenizer->token) {
		this->tokenizer->getToken(this->tokenizer);
	}
	else {
		char buf[32];
		sprintf(buf, "check: %d\n", t);
		this->syntaxError(this, buf);
	}
}

void variableList(Parser *this)
{
	if (this->tokenizer->token != R_VAR) {
		return;
	}
	do {
		char name[256];
		this->tokenizer->getToken(this->tokenizer);	// var̓ǂݔ΂
		strcpy(name, this->tokenizer->value);
		this->check(this, IDENT);
		this->scope->addVariable(this->scope, name);
	} while (this->tokenizer->token == COMMA);
	this->check(this, SEMICOLON);
}

void procedure(Parser *this)
{
	char name[256];
	Identifier *p;
	this->tokenizer->getToken(this->tokenizer);	// procedure ̓ǂݔ΂
	strcpy(name, this->tokenizer->value);
	this->check(this, IDENT);
	p = this->scope->addProcedure(this->scope, name);
	this->scope = this->scope->push(this->scope);
	this->check(this, SEMICOLON);
	this->block(this, p);
	this->check(this, SEMICOLON);
	this->scope = this->scope->pop(this->scope);
}

void procedureList(Parser *this)
{
	while (this->tokenizer->token == R_PROCEDURE) {
		this->procedure(this);
	}
}

void statementList(Parser *this)
{
	this->statement(this);
	while (this->tokenizer->token == SEMICOLON) {
		this->tokenizer->getToken(this->tokenizer);
		this->statement(this);
	}
}

void factor(Parser *this)
{
	char name[256];
	int num;
	Identifier *p;
	switch (this->tokenizer->token) {
	case IDENT:
		strcpy(name, this->tokenizer->value);
		this->tokenizer->getToken(this->tokenizer);
		p = this->scope->search(this->scope, name);
		this->vm->gen(this->vm, F_LOD, this->scope->level - p->level, p->addr);
		break;
	case NUMBER:
		num = atoi(this->tokenizer->value);
		this->tokenizer->getToken(this->tokenizer);
		this->vm->gen(this->vm, F_LIT, 0, num);
		break;
	case LPAREN:
		this->tokenizer->getToken(this->tokenizer);
		this->expression(this);
		this->check(this, RPAREN);
		break;
	default:
		this->syntaxError(this, "factor");
	}
}

void term(Parser *this)
{
	this->factor(this);
	while (this->tokenizer->token == OP_MUL) {
		char op[64];
		strcpy(op, this->tokenizer->value);
		this->tokenizer->getToken(this->tokenizer);
		this->factor(this);
		this->vm->gen(this->vm, F_OPR, 0, optable(op));
	}
}

void expression(Parser *this)
{
	this->term(this);
	while (this->tokenizer->token == OP_ADD) {
		char op[64];
		strcpy(op, this->tokenizer->value);
		this->tokenizer->getToken(this->tokenizer);
		this->term(this);
		this->vm->gen(this->vm, F_OPR, 0, optable(op));
	}
}

void condition(Parser *this)
{
	if (this->tokenizer->token == R_ODD) {
		this->tokenizer->getToken(this->tokenizer); // skip "odd"
		this->expression(this);
		this->vm->gen(this->vm, F_OPR, 0, V_ODD);
	}
	else {
		this->expression(this);
		while (this->tokenizer->token == OP_COMP) {
			char op[64];
			strcpy(op, this->tokenizer->value);
			this->tokenizer->getToken(this->tokenizer);
			this->expression(this);
			this->vm->gen(this->vm, F_OPR, 0, optable(op));
		}
	}
}

void assignStatement(Parser *this)
{
	char name[256];
	Identifier *p;
	strcpy(name, this->tokenizer->value);
	this->tokenizer->getToken(this->tokenizer);
	p = this->scope->search(this->scope, name);
	this->check(this, OP_BECOMES);
	this->expression(this);
	this->vm->gen(this->vm, F_STO, this->scope->level - p->level, p->addr);
}

void callProcedure(Parser *this)
{
	char name[256];
	Identifier *p;
	this->tokenizer->getToken(this->tokenizer);	// skip "call"
	strcpy(name, this->tokenizer->value);
	this->check(this, IDENT);
	p = this->scope->search(this->scope, name);
	this->vm->gen(this->vm, F_CAL, this->scope->level - p->level, p->addr);
}

void ifStatement(Parser *this)
{
	int x;
	this->tokenizer->getToken(this->tokenizer);	// skip "if"
	this->condition(this);
	x = this->vm->gen(this->vm, F_JPC, 0, 0);
	this->check(this, R_THEN);
	this->statement(this);
	this->vm->backPatch(this->vm, x);
}

void whileStatement(Parser *this)
{
	int x1;
	int x2;
	this->tokenizer->getToken(this->tokenizer);	// skip "while"
	x1 = this->vm->currentCx(this->vm);
	this->condition(this);
	x2 = this->vm->gen(this->vm, F_JPC, 0, 0);
	this->check(this, R_DO);
	this->statement(this);
	this->vm->gen(this->vm, F_JMP, 0, x1);
	this->vm->backPatch(this->vm, x2);
}

void statement(Parser *this)
{
	switch (this->tokenizer->token) {
	case IDENT:
		this->assignStatement(this);
		break;
	case R_CALL:
		this->callProcedure(this);
		break;
	case R_IF:
		this->ifStatement(this);
		break;
	case R_WHILE:
		this->whileStatement(this);
		break;
	case R_PRINT:
		this->tokenizer->getToken(this->tokenizer);	// skip "print"
		this->expression(this);
		this->vm->gen(this->vm, F_OPR, 0, V_PRT);
		break;
	case R_BEGIN:
		this->tokenizer->getToken(this->tokenizer);
		this->statementList(this);
		this->check(this, R_END);
		break;
	default:
		// 
		break;
	}
}

void block(Parser *this, Identifier *p)
{
	int x = this->vm->gen(this->vm, F_JMP, 0, 0);		// x:葱̑OQƗp
	this->variableList(this);
	this->procedureList(this);
	this->vm->backPatch(this->vm, x);
	if (p) {
		p->addr = this->vm->codeAlloc;
	}
	this->vm->gen(this->vm, F_INT, 0, this->scope->dataAlloc);		// [Jϐ̊m
	this->statement(this);
	this->vm->gen(this->vm, F_OPR, 0, V_RET);
}

void parse(Parser *this)
{
	this->tokenizer->getToken(this->tokenizer);
	this->block(this, NULL);
	this->check(this, PERIOD);
	this->vm->dump(this->vm);
	this->vm->interprete(this->vm);
}

void compileAndRun(char *s)
{
	VM *vm = new_VM();
	Parser *parser = new_Parser(s, vm);
	parser->parse(parser);
	delete_Parser(parser);
	delete_VM(vm);
}

int main(int argc, char *argv[])
{
	FILE *fp;
	char *s = NULL;
	int len = 0;
	char buf[1024];
	if (argc < 2) {
		printf("usage: pl0 filename\n");
		return(-1);
	}
	if ((fp = fopen(argv[1], "rb")) == NULL) {
		printf("fail to open file \"%s\"\n", argv[1]);
		return(-1);
	}
	while (fgets(buf, sizeof(buf), fp) != NULL) {
		s = realloc(s, len + strlen(buf) + 1);
		strcpy(&s[len], buf);
		len = strlen(s);
	}
	fclose(fp);
	compileAndRun(s);
	if (s) {
		free(s);
	}
	return(0);
}
