/*
 *  This is a header file for minic compiler-interpreter.
 *  regex.h - Regular expression pattern matching and replacement
 *
 *  Copyright (C) 2005 Seiji Tamura
 */
#ifndef REGEX_H
#define REGEX_H

#define MAXTAG  10
#define ERR_RE_EXEC -1
#define ERR_RE_COMP -2

typedef struct rx_result_set {
	int pos;
	int len;
}	rx_result_set_t;

typedef struct rx_result {
	int rset_cnt;
	rx_result_set_t rset[MAXTAG];
}	rx_result_t;

extern int rx_search(char *text, char *pat, rx_result_t *res);
extern int rx_re_search(char *text, char *pat, rx_result_t *res);

#endif /* REGEX_H */
