/*
 *  This is a header file for minic compiler-interpreter.
 *  stdio.h - Definitions for standard input and output
 *
 *  Copyright (C) 2005 Seiji Tamura
 */
#ifndef STDIO_H
#define STDIO_H

#define NULL	0
#define EOF	(-1)

/* ϥХåե(ե빽¤) */
/* С˥ʤȡ */
#ifndef _FILE_DEFINED
#define _FILE_DEFINED
typedef struct _iobuf {
	char	*_ptr;
	int	_cnt;
	char	*_base;
	int	_flag;
	int	_file;
	int	_charbuf;
	int	_bufsiz;
	char	*_tmpfname;
}	FILE;
#endif /* _FILE_DEFINED */

/* stdio.h٤ǤϤʤ */
/* TRUE FALSE Ϥ褯ȤΤǤ */
#define FALSE	0
#define TRUE	1

/* Function prototypes */
extern FILE *fopen(char *fname, char *opt);
extern int fclose(FILE *fp);

extern int fprintf(FILE *fp, char *fmt, ...);
extern int printf(char *fmt, ...);
extern int sprintf(char *buf, char *fmt, ...);

extern int fscanf(FILE *fp, char *format, ...);
extern int scanf(char *format, ...);
extern int sscanf(char *s, char *format, ...);

extern int fgetc(FILE *fp);
extern char *fgets(char *buf, int len, FILE *fp);
extern int fputc(int c, FILE *fp);
extern int fputs(char *s, FILE *fp);
extern int getc(FILE *fp);
extern int getchar();
extern int putc(int c, FILE *fp);
extern int putchar(int c);

//FILE *fopen(const char *filename, const shar *mode);
//FILE *freopen(const char *filename, const char *mode, FILE *stram);
//int fflush(FILE *stream);
//int remove(const char *filename);
//int fclose(FILE *stream);
//int rename(const char *oldname, const char *newname);
//FILE *tmpfile(void);
//char *tmpnam(char s[L_tmpnam]);
//int setvbuf(FILE *stream, char *buf, int mode, size_t size);
//void setbuf(FILE *stream, char *buf);
//
//int fprintf(FILE *stream, const char *format, ...);
//int printf(const char *format, ...);
//int sprintf(char *s, const char *format, ...);
//int vprintf(const char *format, va_list arg);
//int vfprintf(FILE *stream, const char *format, va_list arg);
//int vsprintf(char *s, const char *format, va_list arg);
//
//int fscanf(FILE *stream, const char *format, ...);
//int scanf(const chart *format, ...);
//int sscanf(char *s, const char *format, ...);
//
//int fgetc(FILE *stream);
//char *fgets(char *s, int n, FILE *stream);
//int fputc(int c, FILE *stream);
//int fputs(const char *s, FILE *stream);
//int getc(FILE *stream);
//int getchar(void);
//char *gets(char *s);
//int putc(int c, FILE *stream);
//int putchar(int c);
//int puts(const char *s);
//int ungetc(int c, FILE *stream);
//
//size_t fread(void *ptr, size_t size, size_t nobj, FILE *stream);
//size_t fwrite(const void *ptr, size_t size, size_t nobj, FILE *stream);
//
//int fseek(FILE *stream, long offset, int origin);
//long ftell(FILE *stream);
//void rewind(FILE *stream);
//int fgetpos(FILE *stream, fpos_t *ptr);
//int fsetpos(FILE *stream, const fpos_t *ptr);
//
//void clearerr(FILE *stream);
//int feof(FILE *stream);
//int ferror(FILE *stream);
//void perror(const char *s);

#endif /* STDIO_H */
