/*
 *  This is a header file for minic compiler-interpreter.
 *  string.h - Definitions for memory and string functions
 *
 *  Copyright (C) 2005 Seiji Tamura
 */
#ifndef STRING_H
#define STRING_H

#ifndef _SIZE_T_DEFINED
#define _SIZE_T_DEFINED
typedef int	size_t;
#endif /* _SIZE_T_DEFINED */

/* Function prototypes */
extern void *memcpy(void *to, void *from, size_t size);
extern void *memset(void *buf, int value, size_t size);
extern char *strcpy(char *to, char *from);
extern size_t strlen(char *str);
extern int strcmp(char *cs, char *ct);
extern int strncmp(char *cs, char *ct, size_t n);

//char *strcpy(char *s, const char *ct);
//char *strncpy(char *s, const char *ct, size_t n);
//char *strcat(char *s, const char *ct);
//char *strncat(char *s, const char *ct, size_t n);
//int strcmp(const char *cs, const char *ct);
//int strncmp(const char *cs, const char *ct, size_t n);
//char *strchr(const char *cs, int c);
//char *strrchr(const char *cs, int c);
//size_t strspn(const char *cs, const char *ct);
//size_t strcspn(const char *cs, const char *ct);
//char *strpbrk(const char *cs, const char *ct);
//char *strstr(const char *cs, const char *ct);
//size_t strlen(const char *cs);
//char *strerror(size_t n);
//char *strtok(char *s, const char *ct);
//
//void memcpy(char *s, const char *ct, size_t n);
//void memmove(char *s, const char *ct, size_t n);
//int memcmp(const char *cs, const char *ct, size_t n);
//void *memchr(const char *cs, int c, size_t n);
//void *memset(char *s, int c, size_t n);

#endif /* STRING_H */
