/*
 *  bf_search.c - brute-force algorithm
 *
 *  Copyright (C) 2005 Seiji Tamura
 *
 *  ignore 0 : case sensitive
 *  ignore 1 : ignore cases
 */
#include "bf_search.h"

int bf_search(char *text, int textlen, char *pat, int patlen, int ignore)
{
	int i, j, mx;

	i = 0;
	mx = textlen - patlen + 1;
	if (ignore) goto IGNORE1;

	while (i < mx) {
		if (text[i] == *pat) {
			j = 1;
			while (j < patlen) {
				if (text[i + j] != pat[j])
					goto NOT_MATCH1;
				j++;
			}
			return(i);
		}
NOT_MATCH1:
		i++;
	}
	return(-1);

IGNORE1:
	while (i < mx) {
		if (up_case(text[i]) == up_case(*pat)) {
			j = 1;
			while (j < patlen) {
				if (up_case(text[i + j]) != up_case(pat[j]))
					goto NOT_MATCH2;
				j++;
			}
			return(i);
		}
NOT_MATCH2:
		i++;
	}
	return(-1);
}

int bf_re_search(char *text, int textlen, char *pat, int patlen, int ignore)
{
	int i, j, mn;

	i = textlen - patlen;
	mn = - 1;
	if (ignore) goto IGNORE2;

	while (i > mn) {
		if (text[i] == *pat) {
			j = 1;
			while (j < patlen) {
				if (text[i + j] != pat[j])
					goto NOT_MATCH3;
				j++;
			}
			return(i);
		}
NOT_MATCH3:
		i--;
	}
	return(-1);

IGNORE2:
	while (i > mn) {
		if (up_case(text[i]) == up_case(*pat)) {
			j = 1;
			while (j < patlen) {
				if (up_case(text[i + j]) != up_case(pat[j]))
					goto NOT_MATCH4;
				j++;
			}
			return(i);
		}
NOT_MATCH4:
		i--;
	}
	return(-1);
}
