/*
 *  bm_search.h - Boyer-Moore algorithm
 *
 *  Copyright (C) 2005 Seiji Tamura
 *
 *  ignore 0 : case sensitive
 *  ignore 1 : ignore cases
 */
#ifndef BM_SEARCH_H
#define BM_SEARCH_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef max
#define max(a, b) (((a) > (b)) ? (a) : (b))
#endif
#ifndef min
#define min(a, b) (((a) < (b)) ? (a) : (b))
#endif
#ifndef up_case
#define up_case(a) ((((a) >= 0x61) && ((a) <= 0x7a)) ? ((a) - 0x20) : (a))
#endif
#ifndef lw_case
#define lw_case(a) ((((a) >= 0x41) && ((a) <= 0x5a)) ? ((a) + 0x20) : (a))
#endif

int bm_search(unsigned char *text, int text_len,
              unsigned char *pattern, int pat_len,
              int ignore);
int bm_re_search(unsigned char *text, int text_len,
                 unsigned char *pattern, int pat_len,
                 int ignore);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* BM_SEARCH_H */
