/*
 *  mc_regex.c - Regular expression pattern matching and replacement
 *
 *  Copyright (C) 2005 Seiji Tamura
 */
#include "regex/regex.h"
#include "mc_regex.h"

extern char *bopat[];
extern char *eopat[];

int rx_search(char *text, int tlen, char *pat, int plen, rx_result_t *res)
{
	char *p;
	int ret = ERR_RE_EXEC;

	if ((p = re_comp(pat)) != 0) {
		return(ERR_RE_COMP);
	}

	if (re_exec(text)) {
		ret = bopat[0] - text;
		if (res) {
			int i;
			res->rset_cnt = 0;
			for (i = 0; i < MAXTAG; i++) {
				if (bopat[i]) {
					res->rset[i].pos = bopat[i] - text;
					res->rset[i].len = eopat[i] - bopat[i];
					res->rset_cnt = i + 1;
				}
				else {
					break;
				}
			}
		}
	}
	return(ret);
}

int rx_re_search(char *text, int tlen, char *pat, int plen, rx_result_t *res)
{
	return(-1);
}
