/*
 *  mc_regex.h - Regular expression pattern matching and replacement
 *
 *  Copyright (C) 2005 Seiji Tamura
 */
#ifndef MC_REGEX_H
#define MC_REGEX_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define MAXTAG  10
#define ERR_RE_EXEC -1
#define ERR_RE_COMP -2

#ifndef max
#define max(a, b) (((a) > (b)) ? (a) : (b))
#endif
#ifndef min
#define min(a, b) (((a) < (b)) ? (a) : (b))
#endif
#ifndef up_case
#define up_case(a) ((((a) >= 0x61) && ((a) <= 0x7a)) ? ((a) - 0x20) : (a))
#endif
#ifndef lw_case
#define lw_case(a) ((((a) >= 0x41) && ((a) <= 0x5a)) ? ((a) + 0x20) : (a))
#endif

typedef struct rx_result_set {
	int pos;
	int len;
}	rx_result_set_t;

typedef struct rx_result {
	int rset_cnt;
	rx_result_set_t rset[MAXTAG];
}	rx_result_t;

int rx_search(char *text, int tlen, char *pat, int plen, rx_result_t *res);
int rx_re_search(char *text, int tlen, char *pat, int plen, rx_result_t *res);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* MC_REGEX_H */
