/* 
 *  regex test
 *  Copyright (C) 2005 Seiji Tamura
 */
#include <stdio.h>
#include <string.h>
#include "mc_regex.h"

void print_result(char *text, char *pat, rx_result_t *pres)
{
	int i;
	char buf[1024];
	for (i = 0; i < pres->rset_cnt; i++) {
		printf("pos: %d\n", pres->rset[i].pos);
		printf("len: %d\n", pres->rset[i].len);
		memset(buf, 0, sizeof(buf));
		memcpy(buf, text + pres->rset[i].pos, pres->rset[i].len); 
		printf("pat: %s\n", buf);
		printf("--------\n");
	}

}

void test_search(char *text, char *pat)
{
	rx_result_t res;
	int ret;

	printf("\n---- search pat [%s] ----\n", pat);
	ret = rx_search(text, strlen(text), pat, strlen(pat), &res);
	if (ret >= 0) {
		print_result(text, pat, &res);
	}
	else {
		printf("fail to search [%s] (ret = %d)\n", pat, ret);
	}
}

int main(int argc, char *argv[])
{
	char *text = "abcdefg1234567";
	char *pat1 = "a.*2";
	char *pat2 = "\\([e-g]\\)\\(.*\\)\\(5\\)";
	char *pat3 = "\\([e-g]\\)\\([1-5]+\\)";
	char *pat4 = "zzz";
	char *pat5 = "zzz\\(";

	printf("\n---- text is [%s] ----\n", text);
	test_search(text, pat1);
	test_search(text, pat2);
	test_search(text, pat3);
	test_search(text, pat4);
	test_search(text, pat5);

	return(0);
}
