/*
 *  error.c - Reporting errors
 *
 *  Copyright (C) 2003 Seiji Tamura
 */
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

extern int errcnt;
extern char *filename;
extern int tokenline;

/* global variables */
/* none */

/* global functions */
void yyerror(char *s);
void fatal(char *s);
void parse_error(char *s);
void runerror(char *s);

/* local variables */
/* none */

/* local functions */
/* none */

void yyerror(char *s)
{
	printf("%s%4d: %s\n", filename, tokenline, s);
	errcnt++;
}

void yyerror2(char *s, int d)
{
	printf("%s%4d: %s: %d\n", filename, tokenline, s, d);
	errcnt++;
}

void fatal(char *s)
{
	yyerror(s);
	exit(1);
}

void parse_error(char *s)
{
	yyerror(s);
	exit(1);
}

void parse_error2(char *s, int errline)
{
	printf("%s%4d: %s\n", filename, errline, s);
	errcnt++;
	exit(1);
}

void runerror(char *s)
{
	printf("%s\n", s);
	errcnt++;
	exit(1);
}

void runerror2(char *s, int errline)
{
	printf("%4d: %s\n", errline, s);
	errcnt++;
	exit(1);
}
