/*
 *  expr.c - Evaluation of expression
 *
 *  Copyright (C) 2003 Seiji Tamura
 */
#include <stdio.h>
#include "common.h"

/* memo */
/* ƴؿϺͤʤTRUE֤ */
/* ݥ󥿤­ϣ֣ͤȽꤷƤ */
/* ѿ([]Τʤ)Ȥ­ϡ */
/* ȽꤷƤ(ݥ󥿤⤳Ƚꤷ...)  */

#define FALSE	0
#define TRUE	1

#define GetToken() tok=gettoken()

extern token_t *tok;
extern token_t *gettoken();

static int expr0();
static int expr1();
static int expr2();
static int expr3();
static int expr4();
static int expr5();
static int expr6();
static int expr7();
static int expr8();
static int expr9();
static int calc_code(int, int, int);
static int expr10();
static int expr11();
static int expr12();
static int expr13(int, int *);
static int expr14(int, int, int *);
static int get_ident_size(varinf_t *);
static int get_stuni_member_size(varinf_t **);

static char errbuf[256];
static int cur_type;
static varinf_t *curvinf;

int expression(int mode)
{
	int e0;
	varinf_t *tmpvinf;
	tmpvinf = curvinf;
	curvinf = NULL;
	while (1) {
		e0 = expr0();
		if (tok->type != COMMA || mode & MODE_DECLARE)
			break;
		popup();
		GetToken();
		curvinf = NULL;
	}
	if (!curvinf)
		curvinf = tmpvinf;
	return(e0);
}

/* = += -= *= /= %= &= |= ^= <<= >>= */
static int expr0()
{
	int e1;
	int op = -1;
	int chkpointer = 0;
	e1 = expr1();
	switch (tok->type) {
	case EQUAL:
		if (e1 == 0)
			yyerror("assignment to non lvalue");
		GetToken();
		if (expr0())
			add_code(LOAD, 0, 0, 0, 0);
		add_code(ASGN, 0, 0, 0, 0);
		e1 = TRUE;
		break;
	case STAREQ:
	case ANDEQ:
	case OREQ:
	case PLUSEQ:
	case MINUSEQ:
	case SLASHEQ:
	case PERCENTEQ:
	case LSHIFTEQ:
	case RSHIFTEQ:
	case UPARROWEQ:
		switch (tok->type) {
		case STAREQ:	op = MUL;	chkpointer=0;	break;
		case ANDEQ:	op = AND;	chkpointer=0;	break;
		case OREQ:	op = OR;	chkpointer=0;	break;
		case PLUSEQ:	op = ADD;	chkpointer=1;	break;
		case MINUSEQ:	op = SUB;	chkpointer=1;	break;
		case SLASHEQ:	op = DIV;	chkpointer=0;	break;
		case PERCENTEQ:	op = MOD;	chkpointer=0;	break;
		case LSHIFTEQ:	op = LSFT;	chkpointer=0;	break;
		case RSHIFTEQ:	op = RSFT;	chkpointer=0;	break;
		case UPARROWEQ:	op = XOR;	chkpointer=0;	break;
		default: parse_error("system error");
		}
		if (e1 == 0)
			yyerror("assignment to non lvalue");
		add_code(CPVAL, 0, 0, 0, 0);
		add_code(LOAD, 0, 0, 0, 0);
		GetToken();
		if (expr0())
			add_code(LOAD, 0, 0, 0, 0);
		add_code(op, 0, 0, chkpointer, 0);
		add_code(ASGN, 0, 0, 0, 0);
		e1 = TRUE;
		break;
	default:
		return(e1);
	}
	return(e1);
}

/* (a)?(b):(c) */
static int expr1()
{
	int e2;
	int L1, L2;
	e2=expr2();
	if (tok->type == QUESTION) {
		if (e2)
			add_code(LOAD, 0, 0, 0, 0);
		L1 = label_next();
		add_code(FJMP, L1, 0, FALSE, 0);
		GetToken();
		if (expression(0))
			add_code(LOAD, 0, 0, 0, 0);
		L2 = label_next();
		add_code(JMP, L2, 0, 0, 0);
		chktoken(COLON, "colon");
		regist_label(L1, add_code(LABEL, L1, 0, 0, 0));
		/*if (expression(0))*/
		/*if (expr0())*/
		if (expr1()) /* e = a ? b : c = d is e = ((a ? b : c) = d) */
			add_code(LOAD, 0, 0, 0, 0);
		regist_label(L2, add_code(LABEL, L2, 0, 0, 0));
		return(FALSE);
	}
	return(e2);
}

/* || */
static int expr2()
{
	int e3;
	int L1;
	e3 = expr3();
	while (tok->type == OROR) {
		if (e3)
			add_code(LOAD, 0, 0, 0, 0);
		L1 = label_next();
		add_code(TJMP, L1, 0, TRUE, 0);
		GetToken();
		e3 = expr3();
		if (e3)
			add_code(LOAD, 0, 0, 0, 0);
		regist_label(L1, add_code(LABEL, L1, 0, 0, 0));
		e3 = FALSE;
	}
	return(e3);
}

/* && */
static int expr3()
{
	int e4;
	int L1;
	e4 = expr4();
	while (tok->type == ANDAND) {
		if (e4)
			add_code(LOAD, 0, 0, 0, 0);
		L1 = label_next();
		add_code(FJMP, L1, 0, TRUE, 0);
		GetToken();
		e4 = expr4();
		if (e4)
			add_code(LOAD, 0, 0, 0, 0);
		regist_label(L1, add_code(LABEL, L1, 0, 0, 0));
		e4 = FALSE;
	}
	return(e4);
}

/* | */
static int expr4()
{
	int e5;
	e5 = expr5();
	while (tok->type == OR) {
		if (e5)
			add_code(LOAD, 0, 0, 0, 0);
		GetToken();
		if (expr5())
			add_code(LOAD, 0, 0, 0, 0);
		add_code(OR, 0, 0, 0, 0);
		e5 = FALSE;
	}
	return(e5);
}

/* ^ */
static int expr5()
{
	int e6;
	e6 = expr6();
	while (tok->type == UPARROW) {
		if (e6)
			add_code(LOAD, 0, 0, 0, 0);
		GetToken();
		if (expr6())
			add_code(LOAD, 0, 0, 0, 0);
		add_code(XOR, 0, 0, 0, 0);
		e6 = FALSE;
	}
	return(e6);
}

/* & */
static int expr6()
{
	int e7;
	e7 = expr7();
	while (tok->type == AND) {
		if (e7)
			add_code(LOAD, 0, 0, 0, 0);
		GetToken();
		if (expr7())
			add_code(LOAD, 0, 0, 0, 0);
		add_code(AND, 0, 0, 0, 0);
		e7 = FALSE;
	}
	return(e7);
}

/* == != */
static int expr7()
{
	int e8;
	e8 = expr8();
	while (tok->type == EQEQ || tok->type == NOTEQ) {
		switch (tok->type) {
		case EQEQ:
			if (e8)
				add_code(LOAD, 0, 0, 0, 0);
			GetToken();
			if (expr8())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(CMP, 0, 0, 0, 0);
			e8 = FALSE;
			break;
		case NOTEQ:
			if (e8)
				add_code(LOAD, 0, 0, 0, 0);
			GetToken();
			if (expr8())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(NCMP, 0, 0, 0, 0);
			e8 = FALSE;
			break;
		default:
			break;
		}
	}
	return(e8);
}

/* < <= > >= */
static int expr8()
{
	int e9;
	e9 = expr9();
	while (tok->type==LT||tok->type==LE||tok->type==GT||tok->type==GE) {
		switch (tok->type) {
		case LT:
			if (e9)
				add_code(LOAD, 0, 0, 0, 0);
			GetToken();
			if (expr9())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(LT, 0, 0, 0, 0);
			e9 = FALSE;
			break;
		case LE:
			if (e9)
				add_code(LOAD, 0, 0, 0, 0);
			GetToken();
			if (expr9())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(LE, 0, 0, 0, 0);
			e9 = FALSE;
			break;
		case GT:
			if (e9)
				add_code(LOAD, 0, 0, 0, 0);
			GetToken();
			if (expr9())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(GT, 0, 0, 0, 0);
			e9 = FALSE;
			break;
		case GE:
			if (e9)
				add_code(LOAD, 0, 0, 0, 0);
			GetToken();
			if (expr9())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(GE, 0, 0, 0, 0);
			e9 = FALSE;
			break;
		default:
			break;
		}
	}
	return(e9);
}

/* << >> */
static int expr9()
{
	int e10;
	int op;
	e10 = expr10();
	while (1) {
		switch (tok->type) {
		case LSHIFT:
			op = LSFT;
			break;
		case RSHIFT:
			op = RSFT;
			break;
		default:
			return(e10);
		}
		if (e10)
			add_code(LOAD, 0, 0, 0, 0);
		GetToken();
		if (expr10())
			add_code(LOAD, 0, 0, 0, 0);
		add_code(op, 0, 0, 0, 0);
		e10 = FALSE;
	}
	return(e10);
}

static int calc_code(int op, int val, int reg)
{
	int pc;
	pc = add_code(CNST, val, sizeof(int), 0, 0);
	add_code(TYPE, NUMBER, sizeof(int), 0, 0);
	add_code(op, 0, 0, reg, 0);
	return(pc);
}

static int arrcalcsize = 1;
/* + - */
static int expr10()
{
	int e11;
	int op, chkptr;
	int arrcalc1, arrcalc2, pc;
	varinf_t *tmpvinf;
	arrcalcsize = 1;
	tmpvinf = curvinf;
	curvinf = NULL;
	e11 = expr11();
	arrcalc1 = arrcalcsize;
	if (!curvinf)
		curvinf = tmpvinf;
	while (1) {
		switch (tok->type) {
		case PLUS:
			op = ADD;
			break;
		case MINUS:
			op = SUB;
			break;
		default:
			return(e11);
		}
		if (e11)
			add_code(LOAD, 0, 0, 0, 0);
		/* ݥ󥿱黻ɤλǤʬʤΤ */
		/* ȤꤢߣƤ                         */
		pc = calc_code(MUL, 1, 0);
		GetToken();
		tmpvinf = curvinf;
		curvinf = NULL;
		arrcalcsize = 1;
		if (expr11())
			add_code(LOAD, 0, 0, 0, 0);
		if (!curvinf)
			curvinf = tmpvinf;
		arrcalc2 = arrcalcsize;
#ifdef DEBUG
		printf("arrcalc1 %d\n", arrcalc1);
		printf("arrcalc2 %d\n", arrcalc2);
#endif
		if (arrcalc1 == 1) {
			if (arrcalc2 == 1) {
				chg_code(pc, NOP, 0, 0, 0, 0);
				chg_code(pc + 1, NOP, 0, 0, 0, 0);
				chg_code(pc + 2, NOP, 0, 0, 0, 0);
				pc = calc_code(MUL, 1, 0);
				chkptr = 1;
				arrcalc1 = arrcalc2;
			}
			else {
				chg_code(pc,CNST,arrcalc2,sizeof(int),0,0);
				chkptr = 0;
				arrcalc1 = arrcalc2;
			}
		}
		else {
			if (arrcalc2 == 1) {
				chg_code(pc, NOP, 0, 0, 0, 0);
				chg_code(pc + 1, NOP, 0, 0, 0, 0);
				chg_code(pc + 2, NOP, 0, 0, 0, 0);
				pc = calc_code(MUL, arrcalc1, 0);
				chkptr = 0;
//				arrcalc1 = arrcalc2;
			}
			else {
				char *msgm = "invalid operands to binary -";
				char *msgp = "invalid operands to binary +";
				if (op == ADD) {
					yyerror(msgp);
				}
				else {
					if (arrcalc1 != arrcalc2) {
						yyerror(msgm);
					}
				}
//				chkptr = 1;
				chkptr = 0;
//				arrcalc1 = arrcalc2;
			}
		}
		add_code(op, 0, 0, chkptr, 0);
		e11 = FALSE;
		if (op == SUB && arrcalc1 > 1 && arrcalc2 > 1) {
			pc=calc_code(DIV, arrcalc1, 0);
		}
		arrcalcsize = (arrcalc1 > arrcalc2) ? (arrcalc1) : (arrcalc2);
	}
	return(e11);
}

/* * / % */
static int expr11()
{
	int e12;
	int op;
	e12 = expr12();
	while (1) {
		switch (tok->type) {
		case STAR:
			op = MUL;
			break;
		case SLASH:
			op = DIV;
			break;
		case PERCENT:
			op = MOD;
			break;
		default:
			return(e12);
		}
		if (e12)
			add_code(LOAD, 0, 0, 0, 0);
		GetToken();
		if (expr12())
			add_code(LOAD, 0, 0, 0, 0);
		add_code(op, 0, 0, 0, 0);
		e12 = FALSE;
	}
	return(e12);
}

//static varinf_t *curvinf;
static type_info cast_tinfo;

/* ñ黻 * & + - ! ~ ++ -- (type) sizeof */
static int expr12()
{
	int e12, e13;
	int op;
	type_info tinfo;
	int st = 0;

	switch (tok->type) {
	case STAR:
		GetToken();
		if (e12 = expr12(), e12) /* ͤǤʤƤLOAD٤? */
			add_code(LOAD, 0, 0, 1, 0);
//		e12 = expr12();
//		add_code(LOAD, 0, 0, 1, 0);
//		if (cur_type == STRUCT || cur_type == UNION) {
//			if (curvinf->ptflag > 0) ;
////				add_code(LOAD , 0, 0, 3, 0);
//		}
//		else	
//		add_code(LOAD , 0, 0, 2, 0);
//		e13 = TRUE; /////////////////////////////////////////////////// OK?
		/* ؿݥ󥿤ξ硢minicVMǤϼºݤˤϥɥ쥹 */
		/* ǼƤ櫓ǤϤʤΤǡäѤȽ  */
		/* ʤФʤʤ                                */
		/*   1. p_func("hello");                               */
		/*   2. (p_func)("hello");                             */
		/*   3. (*p_func)("hello");                            */
		/* 嵭Τ٤ƤƱư򤷤ʤФʤʤ...     */
		/* Ĥޤ3ξ硢LOADѤߤʤСνLOAD */
		/* ʤ褦ˤɬפΤFALSE֤           */
		if (curvinf && curvinf->funcptr)
			e13 = FALSE;
		else
			e13 = TRUE;
		break;
	case AND:
		GetToken();
		e13 = expr13(0, &st);
		add_code(ADRS , 0, 0, 0, 0);
		add_code(CNST, 0, sizeof(int), 0, 0);
		add_code(TYPE, NUMBER, sizeof(int), 0, 0); ////////////////////// 
		add_code(ADD, 0, 0, 0, 0);
		if (arrcalcsize == 1 && curvinf) {
			arrcalcsize = curvinf->tsize;
		}
		e13 = FALSE;
		break;
	case PLUS:
		GetToken();
		e12 = expr12();
		e13 = e12;
		break;
	case MINUS:
		GetToken();
		e12 = expr12();
		add_code(INVT , 0, 0, 0, 0);
//		if (expr12())
//			add_code(LOAD, 0, 0, 0, 0);
//		add_code(CNST, -1, sizeof(int), 0);
//		add_code(TYPE, NUMBER, sizeof(int), 0);
//		add_code(MUL, 0, 0, 0, 0);
		e13 = FALSE;
		break;
	case EXCLAM:
		GetToken();
		e12 = expr12();
		add_code(NOT , 0, 0, 0, 0);
		e13 = FALSE;
		break;
	case TILDE:
		GetToken();
		e12 = expr12();
		add_code(CMPL , 0, 0, 0, 0);
		e13 = FALSE;
		break;
	case PLUSPLUS:
	case MINUSMINUS:
		op = (tok->type == PLUSPLUS) ? (ADD) : (SUB);
		GetToken();
		e13 = expr13(0, &st);
		/* Τȱ黻ˤ褦Τ褦˥ԡ */
		add_code(CPVAL, 0, 0, 0, 0);
		add_code(LOAD, 0, 0, 0, 0);
		add_code(CNST, 1, sizeof(int), 0, 0); /* ȤꤢȤäƤ */ /////
		add_code(TYPE, NUMBER, sizeof(int), 0, 0);
		add_code(op, 0, 0, 1, 0);
		add_code(ASGN, 0, 0, 0, 0);
		e13 = TRUE;
		break;
	case SIZEOF:
		GetToken();
		add_code(CNST, expr_sizeof(), sizeof(int), 0, 0);
		add_code(TYPE, NUMBER, sizeof(int), 0, 0);
		e13 = FALSE;
		break;
	default:
		e13 = expr13(0, &st);
		switch (tok->type) {
		case PLUSPLUS:
			op = ADD;
			break;
		case MINUSMINUS:
			op = SUB;
			break;
		case TYPECAST:
			/* 㥹Ⱦѿ¸ */
			tinfo = cast_tinfo;
			GetToken();
			if (expr12())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(CAST, tinfo.type, tinfo.size, tinfo.pflg, 0);
			arrcalcsize = 1;
			e13 = FALSE;
			return(e13);
		default:
			return(e13);
		}
		add_code(CPVAL, 0, 0, 0, 0);
		/* ԡɥ쥹ͤɤ */
		add_code(LOAD, 0, 0, 0, 0);
		/* åΥǡؤ */
		add_code(EXCHG, 0, 0, 0, 0);
		/* Τȱ黻ˤ褦Τ褦˥ԡ */
		add_code(CPVAL, 0, 0, 0, 0);
		add_code(LOAD, 0, 0, 0, 0);
		add_code(CNST, 1, sizeof(int), 0, 0); /* ȤꤢȤäƤ */ /////
		add_code(TYPE, NUMBER, sizeof(int), 0, 0);
		add_code(op, 0, 0, 1, 0);
		add_code(ASGN, 0, 0, 0, 0);
		/* å夫 */
		add_code(POPUP, 0, 0, 0, 0);
		GetToken();
		e13 = FALSE;
	}
	return(e13);
}

static int create_fptr_code(int lval)
{
	int argcnt = 0;
	add_code(PFRME, 0, 0, 0, "");
	GetToken();
	if (tok->type == RPAR) {
		GetToken();
	}
	else {
		while (1) {
			if (expr0())
				add_code(LOAD, 0, 0, 0, 0);
			add_code(PARG, 0, 0, 0, 0);
			argcnt++;
			if (tok->type != COMMA) {
				break;
			}
			GetToken();
			curvinf = NULL;
		}
		chktoken(RPAR, "right parenthesis");
	}
	add_code(CNST, argcnt, sizeof(int), 0, 0);
	add_code(TYPE, TYPE_INT, sizeof(int), 0, 0);
	add_code(EXCHG, 0, 0, 0, 0);
	if (lval)
		add_code(LOAD, 0, 0, 5, 0);
	add_code(PCALL, 0, 0, 0, "(func_ptr)");
	return(FALSE);
}

//static varinf_t *curvinf;
//static int stuniflg = 0;
static varinf_t *stvinf;

/* ident string lpar etc... */
static int expr13(int stuniflg, int *state)
{
	int e, e14;
	int lval = TRUE;
	varinf_t *vinf;
	int type;
	funcinf_t *finf;
	funcinf_t tmpfinf;
	varinf_t *tmpvinf = NULL;

	switch (tok->type) {
	case IDENT:
		GetToken();
		if (tok->type == LPAR) {
			int argcnt = 0;
			/* ѿ */
			if (stuniflg > 0) {
				vinf = find_struct_member(stvinf, tok->ident);
				if (vinf && vinf->funcptr == 1) {
					vinf->base = stvinf->base;
					goto FUNCPTR_EXPR;
				}
			}
			/* ؿ */
			finf = find_function(0, tok->ident);
			if (finf == NULL) {
				int mode = MODE_GLOBAL;
//				sprintf(errbuf,"\"%s\" undeclared",tok->ident);
//				yyerror(errbuf);
//				return(expr14(lval, stuniflg, state));
				/* ؿϿʤѿξؿݥ */
				vinf = find_var(MODE_LOCAL, tok->ident);
				if (vinf)
					goto FUNCPTR_EXPR;
				tmpfinf.fsize = -1;
				tmpfinf.name = regist_name(mode, tok->ident);
				tmpfinf.ic = 0;
				tmpfinf.argcnt = 0;
				finf = &tmpfinf;
			}
//			/* Ȥ߹ߴؿǤʤ硢fpspic */
//			if (finf->ic >= 0)
				add_code(FRAME,finf->fsize,0,0,finf->name);
			GetToken();
			if (tok->type == RPAR) {
				GetToken();
			}
			else {
				while (1) {
//					e = expression(0);
					e = expr0();
					if (e)
						add_code(LOAD, 0, 0, 0, 0);
					add_code(ARG, 0, 0, 0, 0);
					argcnt++;
					if (tok->type != COMMA) {
						break;
					}
					GetToken();
					curvinf = NULL;
				}
				chktoken(RPAR, "right parenthesis");
			}
			if (finf->argcnt > 0) {
				if (finf->argcnt > argcnt)
					parse_error("too few arguments");
				else if (finf->argcnt < argcnt)
					parse_error("too many arguments");
			}
			/* fpsp򹹿ؿƤӽФ */
//			/* Ȥ߹ߴؿǤʤo2ˤϰ򥻥å */
			/* ȹؿǤʤo2ˤϥե졼ॵ򥻥å */
			if (finf->ic >= 0)
//				argcnt = finf->argsize;
				argcnt = finf->fsize;
			add_code(CALL, finf->ic, argcnt, 0, finf->name);
//			add_code(CALL,finf->ic,finf->argcnt, 0, finf->name);
			/* fpspic */
//			add_code(_FUNCRET, 0, 0, 0, 0);
			vinf = find_var(MODE_LOCAL, finf->name);
			if (vinf) {
				/* Ȥꤢݥ󥿤ɤΤȽǤ */
				if (vinf->ptflag)
					arrcalcsize = sizeof(void *);
				else
					arrcalcsize = 1;
			}
			(*state) = 1;
			lval = FALSE;
			goto FUNCEXPR_END;
FUNCPTR_EXPR:
			if (stuniflg > 0) {
				 /* ¤ΥФΥɥ쥹黻ΰ٤Υեå */
				add_code(CNST, vinf->offset, sizeof(int), 0, 0);
			}
			else if (vinf->confirmed == 0)
				add_code(ADDR, -1, -1, 0, vinf->name);
			else	add_code(ADDR, vinf->base, vinf->offset, 0, 0);
			/* 򥹥åˤĤ */
			/* VMǤCONSTʳϥɥ쥹򰷤Τ+1Ƥ */
			if (stuniflg > 0) {
				add_code(TYPE,TYPE_INT, sizeof(int), 0, 0);
			}
			else {
				add_code(TYPE,TYPE_INT,vinf->size,vinf->ptflag+1, 0);
			}
//			add_code(LOAD, 0, 0, 0, 0);
			if (stuniflg > 0) {
				int type=(vinf->type==TYPENAME)?(vinf->ttype):(vinf->type);
				add_code(ADD, 0, 0, 0, 0);
				add_code(CAST, type, vinf->size, vinf->ptflag+1, 0);
			}

			add_code(FRAME, 0, 0, 1, 0);
			add_code(EXCHGF, 0, 0, 0, 0);
			GetToken();
			if (tok->type == RPAR) {
				GetToken();
			}
			else {
				while (1) {
					e = expr0();
					if (e)
						add_code(LOAD, 0, 0, 0, 0);
					add_code(ARGEX, 0, 0, 0, 0);
					argcnt++;
					if (tok->type != COMMA) {
						break;
					}
					GetToken();
					curvinf = NULL;
				}
				chktoken(RPAR, "right parenthesis");
			}
			/* fpsp򹹿ؿƤӽФ */
			/* ȹؿǤʤo2ˤϥե졼ॵ򥻥å */
			add_code(CNST, argcnt, sizeof(int), 0, 0);
			add_code(TYPE, TYPE_INT, sizeof(int), 0, 0);
//			if (vinf->confirmed == 0)
//				add_code(ADDR, -1, -1, 0, vinf->name);
//			else	add_code(ADDR, vinf->base, vinf->offset, 0, 0);
//			/* 򥹥åˤĤ */
//			/* VMǤCONSTʳϥɥ쥹򰷤Τ+1Ƥ */
//			add_code(TYPE,TYPE_INT,vinf->size,vinf->ptflag+1, 0);
			add_code(EXCHG, 0, 0, 0, 0);
			add_code(LOAD, 0, 0, 0, 0);
			add_code(PCALL, 0, 0, 0, "(func_ptr)");
			(*state) = 1;
			lval = FALSE;
FUNCEXPR_END:
			lval = FALSE;
		}
//		else if (tok->type == COLON) {
//			regist_named_label(tok->ident, add_code(LABEL,0,0,0, 0));
//		}
		else {
			/* ѿ */
			if (stuniflg > 0)
				vinf = find_struct_member(stvinf, tok->ident);
//				vinf = find_struct_member(curvinf, tok->ident);
			else
				vinf = find_var(MODE_LOCAL, tok->ident);
				/*vinf = find_var(1, tok->ident);*/
			if (vinf == NULL) {
				char *vname;

				if (stuniflg > 0) {
					sprintf(errbuf,
					        "\"%s\" undeclared",
					        tok->ident);
					yyerror(errbuf);
					return(expr14(lval, stuniflg, state));
				}
				vname = regist_name(MODE_GLOBAL, tok->ident);
				add_code(ADDR, -1, -1, 0, vname);
				add_code(TYPE, -1, -1, -1, 0);
				curvinf = vinf;
				lval = TRUE;
				break;
			}
			type = vinf->type;
			if (type == TYPENAME)
				type = vinf->ttype;
			else if (type == STRUCT || type == UNION)
//				;	/* do nothing */
				stvinf = vinf;
//				curvinf = vinf;
			else
				yyerror("unknown variable type");
			if (stuniflg > 0) {
//				 /* ¤ΥФΥɥ쥹黻ΰ٤Υեå */
////				add_code(CNST, vinf->offset, vinf->size, 0, 0);
//				add_code(CNST, vinf->offset, sizeof(int), 0, 0);
////				vinf->ptflag++;
//				add_code_s(CNSTS, (char *)vinf->offset, sizeof(char *), 0, 0); // XXXXXXXXX
				add_code(CNST, vinf->offset, sizeof(int), 0, 0);
			}
			else if (vinf->confirmed == 0)
				add_code(ADDR, -1, -1, 0, vinf->name);
			else	add_code(ADDR, vinf->base, vinf->offset, 0, 0);
			/* 򥹥åˤĤ */
			/* VMǤCONSTʳϥɥ쥹򰷤Τ+1Ƥ */
			if (type == STRUCT || type == UNION) {
				if (stuniflg > 0) {
					add_code(TYPE, type, sizeof(int), 0, 0); /////////////////
				}
				else {
					int size = vinf->stuni->size;
					if (vinf->argflag == 1)
						add_code(TYPE,type,size,vinf->ptflag+2, 0);
					else
						add_code(TYPE,type,size,vinf->ptflag+1, 0);
				}
			}
			else {
				if (stuniflg > 0) {
					add_code(TYPE, type, sizeof(int), 0, 0);
				}
				else {
					if (vinf->argflag == 1)
						add_code(TYPE,type,vinf->size,vinf->ptflag+2, 0);
					else
						add_code(TYPE,type,vinf->size,vinf->ptflag+1, 0);
				}
			}
			//printf("vinf->argflag %s %d\n", vinf->name, vinf->argflag);
			if (vinf->argflag == 1) {
				add_code(LOAD, 0, 0, 0, 0);
				lval = FALSE;
			}
			cur_type = type;
			/* ͤͤ.... */
			if (vinf->array[0] != -1)
				lval = FALSE;
			curvinf = vinf;
		}
		break;
	case STRING:
//		add_code(CNSTS, (int)tok->string, sizeof(char *), 0, 0);
		add_code_s(CNSTS, (char *)tok->string, sizeof(char *), 0, 0);
		add_code(TYPE, tok->type, sizeof(char *), 0, 0);
		GetToken();
		lval = FALSE;
		break;
	case NUMBER:
		add_code(CNST, (int)tok->intnum, sizeof(int), 0, 0);
		add_code(TYPE, TYPE_INT, sizeof(int), 0, 0);
		GetToken();
		lval = FALSE;
		break;
	case CHARACTER:
		add_code(CNST, (int)tok->ch, sizeof(int), 0, 0);
		/*add_code(CNST, (int)tok->ch, sizeof(char), 0, 0);*/
		add_code(TYPE, TYPE_CHAR, sizeof(int), 0, 0);
		/*add_code(TYPE, tok->type, sizeof(char), 0, 0);*/
		GetToken();
		lval = FALSE;
		break;
	case DECIMAL:
		add_code_d(CNSTD, tok->decnum, sizeof(double), 0, 0);
		add_code(TYPE, TYPE_DOUBLE, sizeof(double), 0, 0);
		GetToken();
		lval = FALSE;
		break;
	case LPAR:
		GetToken();
		switch (tok->type) {
		/*case IDENT:*/
		case STRUCT:
		case UNION:
		case TYPENAME:
			e14 = FALSE;
			expr_typecast();
			if (tok->type != RPAR)
				parse_error("right parenthesis expected");
			tok->type = TYPECAST;
			return(e14);
		default:
			e = expression(0);
			chktoken(RPAR, "right parenthesis");
			lval = e;
			/* Ĥľ˳Ƥϴؿݥ󥿡 */
			if (tok->type == LPAR) {
				lval = create_fptr_code(lval);
				(*state) = 1;
				curvinf = NULL;
			}
//			lval = FALSE;
			break;
		}
		break;
	default:
		parse_error("unrecognized primary");
		break;
	}
	if ((*state) == 1) {
		tmpvinf = curvinf;
		curvinf = NULL;
	}
	e14 = expr14(lval, stuniflg, state);
	if (!curvinf && tmpvinf)
		curvinf = tmpvinf;
	/* ǳƤϴؿݥ󥿡 */
	if (tok->type == LPAR) {
		e14 = create_fptr_code(e14);
		(*state) = 1;
	}
	return(e14);
}

/* [] . -> */
static int expr14(int lval, int stuniflg, int *state)
{
	int e = lval;
	int dim = 0;
	int maxdim = 0;
	varinf_t *lcvinf = curvinf;
	varinf_t *tmpstvinf;

	while(1) {
		int i;
		int dimsize = 1;
		int ptarr = 0;
		switch (tok->type) {
		case LBRACK:
			if (!lcvinf)
				parse_error("unknown variable");
			if (lcvinf->ptflag) {// && lcvinf->array[0] == -1) {
				if (stuniflg) {
					add_code(ADD, 0, 0, 0, 0);
					add_code(CNST, 0, sizeof(int), 99, 0);
					add_code(TYPE, NUMBER, sizeof(int), 0, 0);
					add_code(EXCHG, 0, 0, 0, 0);
				}
				if (dim == 0 && e) {
					add_code(LOAD, 0, 0, 0, 0);
					e = FALSE;
				}
				ptarr = 1;
			}
			else if (dim == 0 && lcvinf->array[dim] == 0) {
				if (dim == 0 && e) {
					add_code(LOAD, 0, 0, 0, 0);
					e = FALSE;
				}
			}
			if (ptarr && dim + 1 == lcvinf->ptflag && e)
				add_code(LOAD, 0, 0, 0, 0);
			tmpstvinf = stvinf;
			GetToken();
			if (expression(0))
				add_code(LOAD, 0, 0, 0, 0);
			stvinf = tmpstvinf;
			curvinf = lcvinf;		// XXXXXXXXXXXXXXXXXXXX
			i = ++dim;
			while (i < ARR_MAX && lcvinf->array[i] != -1) {
				dimsize *= lcvinf->array[i++];
			}
			if (ptarr && dim < lcvinf->ptflag) {
				if (lcvinf->ptflag == 1) {
					if(lcvinf->type==STRUCT||lcvinf->type==UNION)
						dimsize *= lcvinf->stuni->size;
					else
						dimsize *= lcvinf->tsize;
				}
				else {
					dimsize *= sizeof(void *);
				}
			}
			else if (lcvinf->ptflag && lcvinf->array[0] != -1) {
				dimsize *= sizeof(void *);
			}
			else {
				if(lcvinf->type==STRUCT||lcvinf->type==UNION)
					dimsize *= lcvinf->stuni->size;
				else
					dimsize *= lcvinf->tsize;
			}
//printf("dimsize %d\n", dimsize);
			add_code(CNST, dimsize, sizeof(int), 0, 0);
			add_code(TYPE, NUMBER, sizeof(int), 0, 0);
//			add_code(TYPE, TYPE_INT, 0, 0, 0);
			add_code(MUL, 0, 0, 0, 0);
			add_code(ADD, 0, 0, 0, 0);
			chktoken(RBRACK, "right bracket");
			while (maxdim < ARR_MAX && lcvinf->array[maxdim] != -1)
				maxdim++;
//			if (ptarr && dim < maxdim)
//			if (dim < maxdim)
//			if (dim < maxdim + lcvinf->ptflag)
//				e = FALSE;
//			else
//				e = TRUE;
			if (ptarr) /* ݥν(20071219 б) */
//				e = (!dim&&dim<lcvinf->ptflag)?(FALSE):(TRUE);
				e = (!dim)?(FALSE):(TRUE);
			else
				e = (dim<maxdim)?(FALSE):(TRUE);
			break;
		case DOT:
			if (lcvinf->type != STRUCT && lcvinf->type !=UNION)
				yyerror("something not a structure or union");
			if (stuniflg) {
				int type=(curvinf->type==TYPENAME)?(curvinf->ttype):(curvinf->type);
				add_code(ADD, 0, 0, 0, 0);
				add_code(CAST, type, curvinf->size, curvinf->ptflag+1, 0);
			}
			GetToken();
//			stuniflg++;
			e = expr13(stuniflg + 1, state);
//			stuniflg--;
			if (!stuniflg && !(*state)) {
				int type=(curvinf->type==TYPENAME)?(curvinf->ttype):(curvinf->type);
				add_code(ADD, 0, 0, 0, 0);
				add_code(CAST, type, curvinf->size, curvinf->ptflag+1, 0);
			}
			if (!stuniflg)
				(*state) = 0;
			break;
		case ARROW:
			if (lcvinf->type != STRUCT && lcvinf->type !=UNION)
				yyerror("something not a structure or union");
			if (stuniflg) {
				int type=(curvinf->type==TYPENAME)?(curvinf->ttype):(curvinf->type);
				add_code(ADD, 0, 0, 0, 0);
				add_code(CAST, type, curvinf->size, curvinf->ptflag+1, 0);
			}
			/* ݥͤ */
			if (lcvinf->ptflag != 0)
				add_code(LOAD, 0, 0, 0, 0);
			GetToken();
//			stuniflg++;
			e = expr13(stuniflg + 1, state);
//			stuniflg--;
			if (!stuniflg && !(*state)) {
				int type=(curvinf->type==TYPENAME)?(curvinf->ttype):(curvinf->type);
				add_code(ADD, 0, 0, 0, 0);
				add_code(CAST, type, curvinf->size, curvinf->ptflag+1, 0);
			}
			if (!stuniflg)
				(*state) = 0;
			break;
		default:
			if (!lcvinf)
				return(e);
			if (lcvinf->array[0] == -1)
				return(e);
			while (maxdim < ARR_MAX && lcvinf->array[maxdim] != -1)
				maxdim++;
			if (dim >= maxdim)
				return(e);
			if (lcvinf->ptflag && lcvinf->array[0] == -1)
				ptarr = 1;
			i = ++dim;
			while (i < ARR_MAX && lcvinf->array[i] != -1)
				dimsize *= lcvinf->array[i++];
			if (ptarr && dim < lcvinf->ptflag)
				dimsize *= sizeof(void *);
			else if (lcvinf->ptflag && lcvinf->array[0] != -1)
				dimsize *= sizeof(void *);
			else
				dimsize *= lcvinf->tsize;
			arrcalcsize = dimsize;
			return(e);
		}
	}
	return(e);
}

static int get_type_size(int type)////////////////////////////////XXXXXXXXXXXXXXXXXXXXXX
{
	int size;

	switch (type) {
	case TYPE_CHAR:
	case TYPE_UCHAR:
		size = sizeof(char);
		break;
	case TYPE_DOUBLE:
	case TYPE_FLOAT:
		size = sizeof(double);
		break;
	case TYPE_INT:
	case TYPE_LONG:
	case TYPE_SHORT:
	case TYPE_UINT:
	case TYPE_ULONG:
	case TYPE_USHORT:
		size = sizeof(int);
		break;
	case TYPE_VOID:
		size = sizeof(void);
		break;
	default:
		return(-1);
	}
	return(size);
}

static int get_ident_size(varinf_t *pvinf)
{
	int size;
	int i = 0;
	int array_size = 1;

	if (pvinf->ptflag > 0)
		size = sizeof(void *);
	else
		size = pvinf->tsize;
	while (tok->type == LBRACK) {
		do {
			GetToken();
		} while (tok->type != RBRACK);
		i++;
		GetToken();
	}
	while (i < ARR_MAX && pvinf->array[i] > 0)
		array_size *= pvinf->array[i++];
	size *= array_size;

	return(size);
}

static int get_stuni_member_size(varinf_t **pvinf)
{
	int size = 0;

	if (tok->type == DOT || tok->type == ARROW) {
		GetToken();
		if (*pvinf == NULL) {
			yyerror("error: sizeof expression");
			GetToken();
			return(0);
		}
		*pvinf = find_struct_member(*pvinf, tok->ident);
		if (*pvinf) {
			GetToken();
			size = get_ident_size(*pvinf);
		}
		else {
			yyerror("something not a structure or union");
			GetToken();
			return(0);
		}
	}
	else {
		yyerror("error: sizeof expression");
		GetToken();
		return(0);
	}

	return(size);
}

int expr_sizeof()
{
	int size;
	varinf_t *pvinf;
	stuninf_t *pstuni;

	size = 0;
	if (tok->type == LPAR) {
		GetToken();
		if (tok->type == TYPENAME) {
			size = get_type_size(tok->ttype);
			GetToken();
			if (tok->type == STAR) {
				do {
					GetToken();
				} while (tok->type == STAR);
				size = sizeof(void *);
			}
		}
		else if (tok->type == STRUCT || tok->type == UNION) {
			GetToken();
			pstuni = find_struct(MODE_LOCAL, tok->ident);
			if (pstuni == NULL) {
				yyerror("error: sizeof expression");
				return(0);
			}
			size = pstuni->size;
			GetToken();
			if (tok->type == STAR) {
				do {
					GetToken();
				} while (tok->type == STAR);
				size = sizeof(void *);
			}
		}
		else if (tok->type == IDENT) {
			pvinf = find_var(MODE_LOCAL, tok->ident);
			/*pvinf = find_var(1, tok->ident);*/
			if (pvinf == NULL) {
				yyerror("error: sizeof expression");
				return(0);
			}
			GetToken();
			size = get_ident_size(pvinf);
			while (tok->type != RPAR) {
				size = get_stuni_member_size(&pvinf);
			}
		}
		else if (tok->type == STAR) {
			int nptr = 1;

			size = sizeof(void *);
			GetToken();
			while (tok->type == STAR) {
				nptr++;
				GetToken();
			}
			if (tok->type == IDENT) {
				pvinf = find_var(MODE_LOCAL, tok->ident);
				/*pvinf = find_var(1, tok->ident);*/
				if (pvinf == NULL) {
					yyerror("error: sizeof expression");
					return(0);
				}
				if (nptr == pvinf->ptflag) {
					if (pvinf->type == TYPENAME)
						size = pvinf->tsize;
					else /* STRUCT or UNION */
						size = pvinf->stuni->size;
				}
				else if (nptr < pvinf->ptflag) {
					size = sizeof(void *);
				}
				else {
					yyerror("error: sizeof expression");
					return(0);
				}
				GetToken();
			}
		}
		else if (tok->type == CHARACTER) {
			size = sizeof('a');
			GetToken();
		}
		else if (tok->type == STRING) {
			size = lenstr(tok->string) + 1;
			GetToken();
		}
		else {
			yyerror("error: sizeof expression");
			return(0);
		}
		chktoken(RPAR, "right parenthesis");
	}
	else {
		if (tok->type == IDENT) {
			pvinf = find_var(MODE_LOCAL, tok->ident);
			/*pvinf = find_var(1, tok->ident);*/
			if (pvinf == NULL) {
				yyerror("error: sizeof expression");
				return(0);
			}
			size = pvinf->size;
		}
//		else if (tok->type == TYPENAME) {
//			size = get_type_size(tok->ttype);
//		}
		else {
			yyerror("error: sizeof expression");
			return(0);
		}
		GetToken();
	}

	return(size);
}

int expr_typecast()
{
	int pflg = 0;
	int size;
	char *err;
	stuninf_t *pstuni;

	switch (tok->type) {
	/*case IDENT:*/
	case STRUCT:
	case UNION:
		cast_tinfo.type = tok->type;
		GetToken();
		pstuni = find_struct(MODE_LOCAL, tok->ident);
		if (pstuni == NULL) {
			yyerror("error: invalid cast");
			return(0);
		}
		while (tok->type != RPAR) {
			GetToken();
			if (tok->type == STAR)
				pflg++;
			else if (tok->type != RPAR)
				yyerror("error: invalid cast");
		}
		size = pstuni->size;
		cast_tinfo.size = (pflg) ? (sizeof(void *)) : (size);
		cast_tinfo.pflg = pflg;
		if (!pflg) {
			err = "error: conversion to non-scalar type requested";
			yyerror(err);
		}
		break;
	case TYPENAME:
		cast_tinfo.type = tok->ttype;
		while (tok->type != RPAR) {
			GetToken();
			if (tok->type == STAR)
				pflg++;
			else if (tok->type != RPAR)
				yyerror("error: invalid cast");
		}
		size = get_type_size(tok->ttype);
		cast_tinfo.size = (pflg) ? (sizeof(void *)) : (size);
		cast_tinfo.pflg = pflg;
		break;
	default:
		yyerror("error: invalid cast");
		GetToken();
		break;
	}

	return(0);
}
