/*
 *  funcs.c - Intrinsic functions
 *
 *  Copyright (C) 2003 Seiji Tamura
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "common.h"
#include "libminic.h"

/* memo */
/* Ȥ߹ߴؿ */

static int convert_tm_vm2native(char *, struct tm *);
static int convert_tm_native2vm(char *, struct tm *);
static int if_vsprintf(char *, char *, char *);

extern char *stack;
extern int argsize;
extern int sp;

/* local functions */
//static void check_args(int chk, int cnt, char *fname, int few, int many);

static void check_args(int chk, int cnt, char *fname, int few, int many)
{
	char *fmt = "too %s arguments to function \"%s\"";
	char *which;
	char buf[128];

	if (cnt == chk)
		return;

	if (few && cnt < chk) {
		which = "few";
		sprintf(buf, fmt, which, fname);
		runerror(buf);
	}

	if (many && cnt > chk) {
		which = "many";
		sprintf(buf, fmt, which, fname);
		runerror(buf);
	}

}

void if_getchar(intrcode_t *code)
{
	int ret;
	type_info tinfo1;

	/* ؿƤӽФ */
	ret = getchar();

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_putchar(intrcode_t *code)
{
	int ret, val1;
	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "putchar", 1, 1);

	pop(buf1, sizeof(int));
	val1 = cast2int(&tinfo1, buf1);

	/* ؿƤӽФ */
	ret = putchar(val1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_printf(intrcode_t *code)
{
	int ret;
	type_info tinfo1;
	char *format;
	char tobuf[4096];

	check_args(1, code->o2, "printf", 1, 0);

	format = *((char **)(&stack[sp - argsize]));

	/* ؿƤӽФ */
	ret = if_vsprintf(tobuf, format, &stack[sp - argsize + sizeof(char *)]);
	ret = printf("%s", tobuf);

	/* פͤ򥹥å */
	sp -= argsize;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_malloc(intrcode_t *code)
{
	int val1;
	char *ret;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "malloc", 1, 1);

	pop(&val1, sizeof(int));
//	val1 = *((int *)buf1);

	/* ؿƤӽФ */
	ret = (char *)malloc(val1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

void if_free(intrcode_t *code)
{
	int ret;
	char *pval1;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "free", 1, 1);

	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);

	/* ؿƤӽФ */
	free((void *)pval1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	ret = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_memcpy(intrcode_t *code)
{
	int val1;
	char *ret, *pval1, *pval2;
//	char buf1[32];
	type_info tinfo1;

	check_args(3, code->o2, "memcpy", 1, 1);

	/* 軰Υԡ */
	pop(&val1, sizeof(int));
//	val1 = *((int *)buf1);
	/* Υԡݥ󥿤 */
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);
	/* Υԡݥ󥿤 */
	pop(&pval2, sizeof(char *));
//	pval2 = *((char **)buf1);

	/* ؿmemcpy()ƤӽФ */
	ret = (char *)memcpy(pval2, pval1, val1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

void if_memset(intrcode_t *code)
{
	int val1, val2;
	char *ret, *pval1;
//	char buf1[32];
	type_info tinfo1;

	check_args(3, code->o2, "memset", 1, 1);

	/* 軰ʸ */
	pop(&val1, sizeof(int));
//	val1 = *((int *)buf1);
	/* ʸ */
	pop(&val2, sizeof(int));
//	val2 = *((int *)buf1);
	/* ݥ󥿤 */
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);

	/* ؿmemset()ƤӽФ */
	ret = (char *)memset(pval1, val2, val1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

void if_strcpy(intrcode_t *code)
{
	char *ret, *pval1, *pval2;
//	char buf1[32];
	type_info tinfo1;

	check_args(2, code->o2, "strcpy", 1, 1);

	/* Υԡݥ󥿤 */
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);
	/* Υԡݥ󥿤 */
	pop(&pval2, sizeof(char *));
//	pval2 = *((char **)buf1);

	/* ؿstrcpy()ƤӽФ */
	ret = (char *)strcpy(pval2, pval1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

void if_fopen(intrcode_t *code)
{
	char *pval1, *pval2;
	FILE *fp;
//	char buf1[32];
	type_info tinfo1;

	check_args(2, code->o2, "fopen", 1, 1);

	/* Υץ⡼ɤ */
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);
	/* Υե̾ */
	pop(&pval2, sizeof(char *));
//	pval2 = *((char **)buf1);

	/* ؿƤӽФ */
	fp = fopen(pval2, pval1);

	/* ͤ򥹥åѤ */
	tinfo1.type = STRUCT;
	tinfo1.size = sizeof(FILE *);
	tinfo1.pflg = 1;
	push(&fp, sizeof(FILE *));
	push_t(&tinfo1);
}

void if_fclose(intrcode_t *code)
{
	int ret;
	FILE *fp;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "fclose", 1, 1);

	pop(&fp, sizeof(FILE *));
//	fp = *((FILE **)buf1);

	/* ؿƤӽФ */
	ret = fclose(fp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_fgetc(intrcode_t *code)
{
	int ret;
	FILE *fp;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "fgetc", 1, 1);

	pop(&fp, sizeof(FILE *));
//	fp = *((FILE **)buf1);

	/* ؿƤӽФ */
	ret = fgetc(fp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_fputc(intrcode_t *code)
{
	int ret, val1;
	FILE *fp;
//	char buf1[32];
	type_info tinfo1;

	check_args(2, code->o2, "fputc", 1, 1);

	pop(&fp, sizeof(FILE *));
//	fp = *((FILE **)buf1);
	pop(&val1, sizeof(int));
//	val1 = *((int *)buf1);

	/* ؿƤӽФ */
	ret = fputc(val1, fp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_fputs(intrcode_t *code)
{
	int ret;
	FILE *fp;
//	char buf1[32];
	type_info tinfo1;
	char *val1;

	check_args(2, code->o2, "fputs", 1, 1);

	pop(&fp, sizeof(FILE *));
//	fp = *((FILE **)buf1);
	pop(&val1, sizeof(char *));
//	val1 = *((char **)buf1);

	/* ؿƤӽФ */
	ret = fputs(val1, fp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_getc(intrcode_t *code)
{
	int ret;
	FILE *fp;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "getc", 1, 1);

	pop(&fp, sizeof(FILE *));
//	fp = *((FILE **)buf1);

	/* ؿƤӽФ */
	ret = getc(fp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_putc(intrcode_t *code)
{
	int ret, val1;
	FILE *fp;
//	char buf1[32];
	type_info tinfo1;

	check_args(2, code->o2, "putc", 1, 1);

	pop(&fp, sizeof(FILE *));
//	fp = *((FILE **)buf1);
	pop(&val1, sizeof(int));
//	val1 = *((int *)buf1);

	/* ؿƤӽФ */
	ret = putc(val1, fp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_strlen(intrcode_t *code)
{
	int ret;
	char *pval1;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "strlen", 1, 1);

	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);

	/* ؿƤӽФ */
	ret = strlen(pval1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

/* ưŪؿƤӽФ  */
void if_dynfunc(intrcode_t *code)
{
	int ret;
	type_info tinfo1;

	printf("if_dynfunc called\n");

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	ret = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_rx_search(intrcode_t *code)
{
	int ret;
	char *pval1, *pval2, *pval3;
//	char buf1[32];
	type_info tinfo1;
	rx_result_t res;
	char *pres;
	int i;
	int rset_size;

	check_args(3, code->o2, "rx_search", 1, 1);

	/* 軰(̥åȤؤΥݥ) */
	pop(&pval1, sizeof(void *));
//	pval1 = *((char **)buf1);
	/* (ѥʸ) */
	pop(&pval2, sizeof(char *));
//	pval2 = *((char **)buf1);
	/* (ƥʸ) */
	pop(&pval3, sizeof(char *));
//	pval3 = *((char **)buf1);

	/* ؿƤӽФ */
	ret = rx_search(pval3, 0, pval2, 0, &res);

	/* 軰֣;Υ֤˥å */
	pres = pval1;
	if (pres) {
		memcpy(pres, &res.rset_cnt, sizeof(res.rset_cnt));
		pres += sizeof(res.rset_cnt);
		rset_size = sizeof(res.rset[0].pos) + sizeof(res.rset[0].len);
		for (i = 0; i < MAXTAG; i++) {
			memcpy(pres, &res.rset[i], sizeof(res.rset[0]));
			pres += rset_size;
		}
	}

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_fgets(intrcode_t *code)
{
	char *ret;
//	char buf1[32];
	type_info tinfo1;
	FILE *fp;
	int len;
	char *buf;

	check_args(3, code->o2, "fgets", 1, 1);

	pop(&fp, sizeof(FILE *));
//	fp = *((FILE **)buf1);

	pop(&len, sizeof(int));
//	len = *((int *)buf1);

	pop(&buf, sizeof(char *));
//	buf = *((char **)buf1);

	/* ؿƤӽФ */
	ret = fgets(buf, len, fp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

void if_fprintf(intrcode_t *code)
{
	int ret;
	type_info tinfo1;
	char tobuf[4096];
	FILE *stream;
	char *format;

	check_args(2, code->o2, "fprintf", 1, 0);

	stream = *((FILE **)(&stack[sp - argsize]));
	format = *((char **)(&stack[sp - argsize + sizeof(char *)]));

	/* ؿƤӽФ */
	ret = if_vsprintf(tobuf, format, &stack[sp - argsize + sizeof(char *) + sizeof(char *)]);
	ret = fprintf(stream, "%s", tobuf);

	/* פͤ򥹥å */
	sp -= argsize;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_sprintf(intrcode_t *code)
{
	int ret;
	type_info tinfo1;
	char *tobuf;
	char *format;

	check_args(2, code->o2, "sprintf", 1, 0);

	tobuf = *((char **)(&stack[sp - argsize]));
	format = *((char **)(&stack[sp - argsize + sizeof(char *)]));

	/* ؿƤӽФ */
	ret = if_vsprintf(tobuf, format, &stack[sp - argsize + sizeof(char *) + sizeof(char *)]);

	/* פͤ򥹥å */
	sp -= argsize;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_amatch(intrcode_t *code)
{
	int ret;
	char *pval1, *pval2;
//	char buf1[32];
	type_info tinfo1;

	check_args(2, code->o2, "amatch", 1, 1);

	/* (ѥʸ) */
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);
	/* (ƥʸ) */
	pop(&pval2, sizeof(char *));
//	pval2 = *((char **)buf1);

	/* ؿƤӽФ */
	ret = mc_amatch(pval2, pval1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_bf_search(intrcode_t *code)
{
	int ret;
	int ignore, plen, tlen;
	char *pat, *text;
//	char buf1[32];
	type_info tinfo1;

	check_args(5, code->o2, "bf_search", 1, 1);

	/* ް(ʸʸ̵롩) */
	pop(&ignore, sizeof(int));
//	ignore = *((int *)buf1);
	/* Ͱ(ѥʸĹ) */
	pop(&plen, sizeof(int));
//	plen = *((int *)buf1);
	/* 軰(ѥʸ) */
	pop(&pat, sizeof(char *));
//	pat = *((char **)buf1);
	/* (ƥʸĹ) */
	pop(&tlen, sizeof(int));
//	tlen = *((int *)buf1);
	/* (ƥʸ) */
	pop(&text, sizeof(char *));
//	text = *((char **)buf1);

	/* ؿƤӽФ */
	ret = bf_search(text, tlen, pat, plen, ignore);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_bf_re_search(intrcode_t *code)
{
	int ret;
	int ignore, plen, tlen;
	char *pat, *text;
//	char buf1[32];
	type_info tinfo1;

	check_args(5, code->o2, "bf_re_search", 1, 1);

	/* ް(ʸʸ̵롩) */
	pop(&ignore, sizeof(int));
//	ignore = *((int *)buf1);
	/* Ͱ(ѥʸĹ) */
	pop(&plen, sizeof(int));
//	plen = *((int *)buf1);
	/* 軰(ѥʸ) */
	pop(&pat, sizeof(char *));
//	pat = *((char **)buf1);
	/* (ƥʸĹ) */
	pop(&tlen, sizeof(int));
//	tlen = *((int *)buf1);
	/* (ƥʸ) */
	pop(&text, sizeof(char *));
//	text = *((char **)buf1);

	/* ؿƤӽФ */
	ret = bf_re_search(text, tlen, pat, plen, ignore);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_bm_search(intrcode_t *code)
{
	int ret;
	int ignore, plen, tlen;
	unsigned char *pat, *text;
//	char buf1[32];
	type_info tinfo1;

	check_args(5, code->o2, "bm_search", 1, 1);

	/* ް(ʸʸ̵롩) */
	pop(&ignore, sizeof(int));
//	ignore = *((int *)buf1);
	/* Ͱ(ѥʸĹ) */
	pop(&plen, sizeof(int));
//	plen = *((int *)buf1);
	/* 軰(ѥʸ) */
	pop(&pat, sizeof(char *));
//	pat = *((unsigned char **)buf1);
	/* (ƥʸĹ) */
	pop(&tlen, sizeof(int));
//	tlen = *((int *)buf1);
	/* (ƥʸ) */
	pop(&text, sizeof(char *));
//	text = *((unsigned char **)buf1);

	/* ؿƤӽФ */
	ret = bm_search(text, tlen, pat, plen, ignore);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_bm_re_search(intrcode_t *code)
{
	int ret;
	int ignore, plen, tlen;
	unsigned char *pat, *text;
//	char buf1[32];
	type_info tinfo1;

	check_args(5, code->o2, "bm_re_search", 1, 1);

	/* ް(ʸʸ̵롩) */
	pop(&ignore, sizeof(int));
//	ignore = *((int *)buf1);
	/* Ͱ(ѥʸĹ) */
	pop(&plen, sizeof(int));
//	plen = *((int *)buf1);
	/* 軰(ѥʸ) */
	pop(&pat, sizeof(char *));
//	pat = *((unsigned char **)buf1);
	/* (ƥʸĹ) */
	pop(&tlen, sizeof(int));
//	tlen = *((int *)buf1);
	/* (ƥʸ) */
	pop(&text, sizeof(char *));
//	text = *((unsigned char **)buf1);

	/* ؿƤӽФ */
	ret = bm_re_search(text, tlen, pat, plen, ignore);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_atoi(intrcode_t *code)
{
	int ret;
	char *pval1;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "atoi", 1, 1);

	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);

	/* ؿƤӽФ */
	ret = atoi(pval1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_realloc(intrcode_t *code)
{
	int val1;
	char *pval1;
	char *ret;
//	char buf1[32];
	type_info tinfo1;

	check_args(2, code->o2, "realloc", 1, 1);

	pop(&val1, sizeof(int));
//	val1 = *((int *)buf1);
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);

	/* ؿƤӽФ */
	ret = (char *)realloc(pval1, val1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

extern int cb_i_pv_pv(const void *pv1, const void *pv2);
extern int vm_fp;

void if_qsort(intrcode_t *code)
{
	int ret = 0;
	int n, size, cmp, tmp_vm_fp;
	char *base;
//	char buf1[32];
	type_info tinfo1;

	check_args(4, code->o2, "qsort", 1, 1);

	pop(&cmp, sizeof(int));
//	cmp = *((int *)buf1);
	pop(&size, sizeof(int));
//	size = *((int *)buf1);
	pop(&n, sizeof(int));
//	n = *((int *)buf1);
	pop(&base, sizeof(char *));
//	base = *((char **)buf1);

	tmp_vm_fp = vm_fp;
	vm_fp = cmp;

	/* ؿƤӽФ */
	qsort(base, n, size, cb_i_pv_pv);

	vm_fp = tmp_vm_fp;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

extern int sp;
extern int fp;
extern int ic;
extern int chksp;

void if_abort(intrcode_t *code)
{
	int exitcd;
	type_info tinfo1;

	exitcd = 0;

	sp = 8;
	fp = 0;
	ic = 7;
	chksp = 0;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&exitcd, sizeof(int));
	push_t(&tinfo1);
}

void if_exit(intrcode_t *code)
{
	int exitcd;
//	char buf1[32];
	type_info tinfo1;

	check_args(1, code->o2, "exit", 1, 1);

	pop(&exitcd, sizeof(int));
//	exitcd = *((int *)buf1);

//	sp = 4; // 20090421
	sp = 8; // 20090421
	fp = 0;
	ic = 7;
	chksp = 0;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&exitcd, sizeof(int));
	push_t(&tinfo1);
}

void if_fscanf(intrcode_t *code)
{
	int ret, i;
	char *args[20];
	type_info tinfo1;
	char *format;
	FILE *fp;

	check_args(22, code->o2, "fscanf", 0, 1);

	for (i = 0; i < 20; i++)
		args[i] = NULL;

	for (i = code->o2 - 2 - 1; i >= 0; i--) {
		pop(&args[i], sizeof(char *));
	}
	pop(&format, sizeof(char *));
	pop(&fp, sizeof(FILE *));

	/* ؿƤӽФ */
	ret = fscanf(fp, format, args[0], args[1], args[2], args[3],
	             args[4], args[5], args[6], args[7], args[8],
	             args[9], args[10], args[11], args[12], args[13],
	             args[14], args[15], args[16], args[17], args[18],
	             args[19]);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_scanf(intrcode_t *code)
{
	int ret, i;
	char *args[20];
	type_info tinfo1;
	char *format;

	check_args(21, code->o2, "scanf", 0, 1);

	for (i = 0; i < 20; i++)
		args[i] = NULL;

	for (i = code->o2 - 1 - 1; i >= 0; i--) {
		pop(&args[i], sizeof(char *));
	}
	pop(&format, sizeof(char *));

	/* ؿƤӽФ */
	ret = scanf(format, args[0], args[1], args[2], args[3],
	            args[4], args[5], args[6], args[7], args[8],
	            args[9], args[10], args[11], args[12], args[13],
	            args[14], args[15], args[16], args[17], args[18],
	            args[19]);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_sscanf(intrcode_t *code)
{
	int ret, i;
	char *args[20];
	type_info tinfo1;
	char *format;
	char *s;

	check_args(22, code->o2, "sscanf", 0, 1);

	for (i = 0; i < 20; i++)
		args[i] = NULL;

	for (i = code->o2 - 2 - 1; i >= 0; i--) {
		pop(&args[i], sizeof(char *));
	}
	pop(&format, sizeof(char *));
	pop(&s, sizeof(char *));

	/* ؿƤӽФ */
	ret = sscanf(s, format, args[0], args[1], args[2], args[3],
	             args[4], args[5], args[6], args[7], args[8],
	             args[9], args[10], args[11], args[12], args[13],
	             args[14], args[15], args[16], args[17], args[18],
	             args[19]);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_strcmp(intrcode_t *code)
{
	int ret;
	char *pval1, *pval2;
//	char buf1[32];
	type_info tinfo1;

	check_args(2, code->o2, "strcmp", 1, 1);

	/* ʸݥ󥿤 */
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);
	/* ʸݥ󥿤 */
	pop(&pval2, sizeof(char *));
//	pval2 = *((char **)buf1);

	/* ؿmemcpy()ƤӽФ */
	ret = strcmp(pval2, pval1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_strncmp(intrcode_t *code)
{
	int ret;
	int val1;
	char *pval1, *pval2;
//	char buf1[32];
	type_info tinfo1;

	check_args(3, code->o2, "strncmp", 1, 1);

	/* 軰Υԡ */
	pop(&val1, sizeof(int));
//	val1 = *((int *)buf1);
	/* Υԡݥ󥿤 */
	pop(&pval1, sizeof(char *));
//	pval1 = *((char **)buf1);
	/* Υԡݥ󥿤 */
	pop(&pval2, sizeof(char *));
//	pval2 = *((char **)buf1);

	/* ؿstrncmp()ƤӽФ */
	ret = strncmp(pval2, pval1, val1);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

void if_clock(intrcode_t *code)
{
	long ret;
	type_info tinfo1;

	/* ؿƤӽФ */
	ret = clock();

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_LONG;
	tinfo1.size = sizeof(long);
	tinfo1.pflg = 0;
	push(&ret, sizeof(long));
	push_t(&tinfo1);
}

void if_time(intrcode_t *code)
{
	long ret;
	long *tp;
	type_info tinfo1;
	time_t tval;

	check_args(1, code->o2, "time", 1, 1);

	pop(&tp, sizeof(long *));

	/* ؿƤӽФ */
	if (tp) {
		ret = time(&tval);
		*tp = (time_t)tval;
	}
	else {
		ret = time(NULL);
	}

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_LONG;
	tinfo1.size = sizeof(long);
	tinfo1.pflg = 0;
	push(&ret, sizeof(long));
	push_t(&tinfo1);
}

void if_difftime(intrcode_t *code)
{
	double ret;
	long val1, val2;
	type_info tinfo1;

	check_args(2, code->o2, "difftime", 1, 1);

	pop(&val2, sizeof(long));
	pop(&val1, sizeof(long));

	/* ؿƤӽФ */
	ret = difftime(val1, val2);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_DOUBLE;
	tinfo1.size = sizeof(double);
	tinfo1.pflg = 0;
	push(&ret, sizeof(double));
	push_t(&tinfo1);
}

void if_mktime(intrcode_t *code)
{
	long ret;
	char *tp;
	type_info tinfo1;
	struct tm tmptp;

	check_args(1, code->o2, "mktime", 1, 1);

	pop(&tp, sizeof(char *));

	/* minic VM ݻ빽¤Τͤϰ¸ */
	/* ¤Τ ͤؤ                         */
	convert_tm_vm2native(tp, &tmptp);

	/* ؿƤӽФ */
	ret = mktime(&tmptp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_LONG;
	tinfo1.size = sizeof(long);
	tinfo1.pflg = 0;
	push(&ret, sizeof(long));
	push_t(&tinfo1);
}

void if_asctime(intrcode_t *code)
{
	char *ret;
	char *tp;
	type_info tinfo1;
	struct tm tmptp;

	check_args(1, code->o2, "asctime", 1, 1);

	pop(&tp, sizeof(char *));

	/* minic VM ݻ빽¤Τͤϰ¸ */
	/* ¤Τ ͤؤ                         */
	convert_tm_vm2native(tp, &tmptp);

	/* ؿƤӽФ */
	ret = asctime(&tmptp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

void if_ctime(intrcode_t *code)
{
	char *ret;
	long *tp;
	type_info tinfo1;

	check_args(1, code->o2, "ctime", 1, 1);

	pop(&tp, sizeof(long *));

	/* ؿƤӽФ */
	ret = ctime(tp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_CHAR;
	tinfo1.size = sizeof(char *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(char *));
	push_t(&tinfo1);
}

void if_gmtime(intrcode_t *code)
{
	char *ret;
	long *tp;
	type_info tinfo1;
	struct tm *ptmptp;
	static char tm_buf[sizeof(int)*10];

	check_args(1, code->o2, "gmtime", 1, 1);

	pop(&tp, sizeof(long *));

	/* ؿƤӽФ */
	ptmptp = gmtime(tp);

	/* minic VM ݻ빽¤Τˡϰ¸ι */
	/* ¤Τͤͤ                            */
	ret = tm_buf;

	*((int *)ret) = ptmptp->tm_sec;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_min;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_hour;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_mday;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_mon;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_year;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_wday;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_yday;
	ret += sizeof(int);

	*((int *)ret) = ptmptp->tm_isdst;

	ret = tm_buf;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_VOID;
	tinfo1.size = sizeof(void *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(void *));
	push_t(&tinfo1);
}

void if_localtime(intrcode_t *code)
{
	char *ret;
	long *tp;
	type_info tinfo1;
	struct tm *ptmptp;
	static char tm_buf[sizeof(int)*10];

	check_args(1, code->o2, "localtime", 1, 1);

	pop(&tp, sizeof(long *));

	/* ؿƤӽФ */
	ptmptp = localtime(tp);

	/* minic VM ݻ빽¤Τˡϰ¸ι */
	/* ¤Τͤͤ                            */
	convert_tm_native2vm(tm_buf, ptmptp);
	ret = tm_buf;

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_VOID;
	tinfo1.size = sizeof(void *);
	tinfo1.pflg = 1;
	push(&ret, sizeof(void *));
	push_t(&tinfo1);
}

void if_strftime(intrcode_t *code)
{
	int ret;
	char *val1, *val3;
	int val2;
	char *tp;
	type_info tinfo1;
	struct tm tmptp;

	check_args(4, code->o2, "strftime", 1, 1);

	pop(&tp, sizeof(char *));
	pop(&val3, sizeof(char *));
	pop(&val2, sizeof(int));
	pop(&val1, sizeof(char *));

	/* minic VM ݻ빽¤Τͤϰ¸ */
	/* ¤Τ ͤؤ                         */
	convert_tm_vm2native(tp, &tmptp);

	/* ؿƤӽФ */
	ret = strftime(val1, val2, val3, &tmptp);

	/* ͤ򥹥åѤ */
	tinfo1.type = TYPE_INT;
	tinfo1.size = sizeof(int);
	tinfo1.pflg = 0;
	push(&ret, sizeof(int));
	push_t(&tinfo1);
}

static int convert_tm_vm2native(char *buf, struct tm *tp)
{
	char *pos = buf;

	tp->tm_sec = *((int *)pos);
	pos += sizeof(int);

	tp->tm_min = *((int *)pos);
	pos += sizeof(int);

	tp->tm_hour = *((int *)pos);
	pos += sizeof(int);

	tp->tm_mday = *((int *)pos);
	pos += sizeof(int);

	tp->tm_mon = *((int *)pos);
	pos += sizeof(int);

	tp->tm_year = *((int *)pos);
	pos += sizeof(int);

	tp->tm_wday = *((int *)pos);
	pos += sizeof(int);

	tp->tm_yday = *((int *)pos);
	pos += sizeof(int);

	tp->tm_isdst = *((int *)pos);
	pos += sizeof(int);

	return(0);
}

static int convert_tm_native2vm(char *buf, struct tm *tp)
{
	char *pos = buf;

	*((int *)pos) = tp->tm_sec;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_min;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_hour;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_mday;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_mon;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_year;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_wday;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_yday;
	pos += sizeof(int);

	*((int *)pos) = tp->tm_isdst;

	return(0);
}

#define formatend(c) ((c)=='o'||(c)=='d'||(c)=='i'||(c)=='x'||(c)=='X'|| \
                      (c)=='u'||(c)=='c'||(c)=='s'||(c)=='f'||(c)=='e'|| \
                      (c)=='E'||(c)=='g'||(c)=='G'||(c)=='p'||(c)=='n'|| \
                      (c)=='%')

static int sprintf_int(char *buf, char *format, int n)
{
	return(sprintf(buf, format, n));
}

static int sprintf_double(char *buf, char *format, double d)
{
	return(sprintf(buf, format, d));
}

static int sprintf_string(char *buf, char *format, char *s)
{
	return(sprintf(buf, format, s));
}

static int sprintf_pointer(char *buf, char *format, char *p)
{
	return(sprintf(buf, format, p));
}
#if 0
static int sprintf_int_pointer(char *buf, char *format, int *pn)
{
	return(sprintf(buf, format, pn));
}
#endif
static int if_vsprintf(char *p, char *format, char *arg)
{
	char *start = p;
	char formatbuf[64];

	while (*format) {
		int i;
		int c = 0;
		int n;
		double d;
		char *ps;
		int *pi;
		switch (*format) {
		case '%':
			i = 0;
			c = *format++;
			formatbuf[i++] = c;
			while (*format) {
				c = *format++;
				formatbuf[i++] = c;
				if (formatend(c)) {
					formatbuf[i] = 0;
					break;
				}
			}
			switch (c) {
			case 'o':
			case 'd':
			case 'i':
			case 'x':
			case 'X':
			case 'u':
			case 'c':
				n = *((int *)arg);
				arg = (char *)((int *)arg + 1);
				p += sprintf_int(p, formatbuf, n);
				break;
			case 'f':
			case 'e':
			case 'E':
			case 'g':
			case 'G':
				d = *((double *)arg);
				arg = (char *)((double *)arg + 1);
				p += sprintf_double(p, formatbuf, d);
				break;
			case 's':
				ps = *((char **)arg);
				arg = (char *)((char **)arg + 1);
				p += sprintf_string(p, formatbuf, ps);
				break;
			case 'p':
				ps = *((char **)arg);
				arg = (char *)((char **)arg + 1);
				p += sprintf_pointer(p, formatbuf, ps);
				break;
			case 'n':
				pi = *((int **)arg);
				arg = (char *)((int **)arg + 1);
				*pi = (p - start);
				/*p += sprintf_int_pointer(p, formatbuf, pi);*/
				break;
			case '%':
				*p++ = '%';
				break;
			default:
				*p++ = c;
				break;
			}
			break;
		default:
			*p++ = *format++;
			break;
		}
	}
	*p = '\0';

	return(p - start - 1);
}
