/*
 *  hash.c - Generate a hash value
 *
 *  Copyright (C) 2004 Seiji Tamura
 */
#include "common.h"

int hash_value(char *key, int max)
{
	unsigned int value = 0;
	int weight = 0;

	while (*key) {
		value += ((int)*key) << (4 * (weight & 0x07));
		weight++;
		key++;
	}
	return(value % max);
}

void init_hash(int *table, int size, int value)
{
	int i;

	for (i = 0; i < size; i++)
		table[i] = value;
}
