/*
 *  test for Boyer-Moore algorithm
 */
#include <stdio.h>
#include <string.h>
#include <search.h>

int main(int argc, char **argv[])
{
	char *text, *pat;
	int textlen, patlen;
	int pos, i;

	text = "abcdefghijklmnopqrstuvwxyz0123456789";
	pat = (argc > 1) ? (argv[1]) : ("z012");
	textlen = strlen(text);
	patlen = strlen(pat);

	pos = bm_search(text, textlen, pat, patlen, 0);

	printf("bm_search\n");
	printf("%s\n", text);
	if (pos >= 0) {
		for (i = 0; i < pos; i++)
			putchar(' ');
		printf("%s\n", pat);
	}
	else {
		printf("\"%s\" is not found\n", pat);
	}

	printf("--------\n");

	pat = "def";
	patlen = strlen(pat);
	pos = bm_re_search(text, textlen, pat, patlen, 0);

	printf("bm_re_search\n");
	printf("%s\n", text);
	if (pos >= 0) {
		for (i = 0; i < pos; i++)
			putchar(' ');
		printf("%s\n", pat);
	}
	else {
		printf("\"%s\" is not found\n", pat);
	}

	printf("--------\n");

	pat = "KLM";
	patlen = strlen(pat);
	pos = bm_search(text, textlen, pat, patlen, 1);

	printf("bm_search ignore\n");
	printf("%s\n", text);
	if (pos >= 0) {
		for (i = 0; i < pos; i++)
			putchar(' ');
		printf("%s\n", pat);
	}
	else {
		printf("\"%s\" is not found\n", pat);
	}

	printf("--------\n");

	pat = "KLM";
	patlen = strlen(pat);
	pos = bm_search(text, textlen, pat, patlen, 0);

	printf("bm_search sensitive\n");
	printf("%s\n", text);
	if (pos >= 0) {
		for (i = 0; i < pos; i++)
			putchar(' ');
		printf("%s\n", pat);
	}
	else {
		printf("\"%s\" is not found\n", pat);
	}

	printf("--------\n");

	pat = "XyZ0123";
	patlen = strlen(pat);
	pos = bm_re_search(text, textlen, pat, patlen, 1);

	printf("bm_re_search ignore\n");
	printf("%s\n", text);
	if (pos >= 0) {
		for (i = 0; i < pos; i++)
			putchar(' ');
		printf("%s\n", pat);
	}
	else {
		printf("\"%s\" is not found\n", pat);
	}

	printf("--------\n");

	pat = "XyZ0123";
	patlen = strlen(pat);
	pos = bm_re_search(text, textlen, pat, patlen, 0);

	printf("bm_re_search sensitive\n");
	printf("%s\n", text);
	if (pos >= 0) {
		for (i = 0; i < pos; i++)
			putchar(' ');
		printf("%s\n", pat);
	}
	else {
		printf("\"%s\" is not found\n", pat);
	}

	return(0);
}
