/*
 *  test for Boyer-Moore algorithm
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <search.h>

int main(int argc, char **argv[])
{
	FILE *fp;
	char buf[1024];
	char *text, *pat;
	int textlen, patlen;
	int line, pos, i;

	if (argc < 2) {
		printf("usage: test2 filename [pattern]\n");
		return(-1);
	}

	if ((fp = fopen(argv[1], "r")) == 0) {
		printf("fail to open file (%s)\n", argv[1]);
		return(-1);
	}

	line = 0;
	while (fgets(buf, sizeof(buf), fp) != 0) {
		text = buf;
		pat = (argc > 2) ? (argv[2]) : ("z012");
		textlen = strlen(text);
		patlen = strlen(pat);
		line++;
	
		pos = bm_search(text, textlen, pat, patlen, 0);
	
		if (pos >= 0) {
			printf("%d,%d: ", line, pos);
			printf("%s", text);
			if (text[strlen(text) - 1] != '\n') {
				printf("\n");
			}
		}
	}

	fclose(fp);

	return(0);
}
