/*
 *  test for robust glob pattern matcher
 */
#include <stdio.h>
#include <string.h>
#include <glob.h>

typedef struct pare {
	char *pat;
	char *str;
}	pare_t;

static pare_t test_tbl[100];
//static int test_tbl_cnt = sizeof(test_tbl) / sizeof(test_tbl[0]);
static int test_tbl_cnt = 0;

void init()
{
	int i = 0;
	pare_t *t = test_tbl;
	t[i].pat = "*";                   t[i].str = "a";          i++;
	t[i].pat = "*";                   t[i].str = "abc";        i++;
	t[i].pat = "?";                   t[i].str = "a";          i++;
	t[i].pat = "[";                   t[i].str = "a";          i++;
	t[i].pat = "[--z]";               t[i].str = "-";          i++;
	t[i].pat = "[--z]";               t[i].str = "a";          i++;
	t[i].pat = "[-]abc";              t[i].str = "-abc";       i++;
	t[i].pat = "[-a-]?";              t[i].str = "zd";         i++;
	t[i].pat = "[-abc]?";             t[i].str = "dd";         i++;
	t[i].pat = "[-abc]?";             t[i].str = "-b";         i++;
	t[i].pat = "[a-c][a-c][a-c]";     t[i].str = "abc";        i++;
	t[i].pat = "[]";                  t[i].str = "a";          i++;
	t[i].pat = "[]-z]abc";            t[i].str = "^abc";       i++;
	t[i].pat = "[]]abc";              t[i].str = "]abc";       i++;
	t[i].pat = "[]abc[a]";            t[i].str = "a";          i++;
	t[i].pat = "[]abc[de]";           t[i].str = "[";          i++;
	t[i].pat = "[]abc[de]";           t[i].str = "]";          i++;
	t[i].pat = "[]abc[de]";           t[i].str = "d";          i++;
	t[i].pat = "[^a-z]";              t[i].str = "a";          i++;
	t[i].pat = "[^a-z]";              t[i].str = "A";          i++;
	t[i].pat = "[a-z]";               t[i].str = "a";          i++;
	t[i].pat = "[ab";                 t[i].str = "a";          i++;
	t[i].pat = "[abc]??[def]";        t[i].str = "abca";       i++;
	t[i].pat = "[abc]??[def]";        t[i].str = "abcg";       i++;
	t[i].pat = "[abc]??[def]";        t[i].str = "abcd";       i++;
	t[i].pat = "[b-";                 t[i].str = "a";          i++;
	t[i].pat = "[z-a]";               t[i].str = "a";          i++;
	t[i].pat = "[z-a]";               t[i].str = "z";          i++;
	t[i].pat = "\\?\\?\\*!\\[abc\\]"; t[i].str = "??*![abc]";  i++;
	t[i].pat = "ab[a-z]?a*b";         t[i].str = "abCdaxxxxb"; i++;
	t[i].pat = "ab[a-z]?a*b";         t[i].str = "abc";        i++;
	t[i].pat = "ab[a-z]?a*b";         t[i].str = "abcdab";     i++;
	t[i].pat = "ab[a-z]?a*b";         t[i].str = "abcdaxxxxb"; i++;
	t[i].pat = "xxx";                 t[i].str = "xxx";        i++;
	test_tbl_cnt = i;
}

int main(int argc, char *argv[])
{
	int i;

	init();

	printf("%-16s%-16s: %s\n", "pattern", "string", "result");
	for (i = 0; i < test_tbl_cnt; i++) {
		char *result;
		char *str = test_tbl[i].str;
		char *pat = test_tbl[i].pat;
		result = (amatch(str, pat))?("matched!!"):("not matched...");
		printf("%-16s%-16s: %s\n", pat, str, result);
	}
}
