/*
 *  test for robust glob pattern matcher
 */
#include <stdio.h>
#include <string.h>
#include <glob.h>

typedef struct pare {
	char *pat;
	char *str;
}	pare_t;

static pare_t test_tbl[] = {
	{"*",			"a"		},
	{"*",			"abc"		},
	{"?",			"a"		},
	{"[",			"a"		},
	{"[--z]",		"-"		},
	{"[--z]",		"a"		},
	{"[-]abc",		"-abc"		},
	{"[-a-]?",		"zd"		},
	{"[-abc]?",		"dd"		},
	{"[-abc]?",		"-b"		},
	{"[a-c][a-c][a-c]",	"abc"		},
	{"[]",			"a"		},
	{"[]-z]abc",		"^abc"		},
	{"[]]abc",		"]abc"		},
	{"[]abc[a]",		"a"		},
	{"[]abc[de]",		"["		},
	{"[]abc[de]",		"]"		},
	{"[]abc[de]",		"d"		},
	{"[^a-z]",		"a"		},
	{"[^a-z]",		"A"		},
	{"[a-z]",		"a"		},
	{"[ab",			"a"		},
	{"[abc]??[def]",	"abca"		},
	{"[abc]??[def]",	"abcg"		},
	{"[abc]??[def]",	"abcd"		},
	{"[b-",			"a"		},
	{"[z-a]",		"a"		},
	{"[z-a]",		"z"		},
	{"\\?\\?\\*!\\[abc\\]",	"??*![abc]"	},
	{"ab[a-z]?a*b",		"abCdaxxxxb"	},
	{"ab[a-z]?a*b",		"abc"		},
	{"ab[a-z]?a*b",		"abcdab"	},
	{"ab[a-z]?a*b",		"abcdaxxxxb"	},
	{"xxx",			"xxx"		}
};
static int test_tbl_cnt = sizeof(test_tbl) / sizeof(test_tbl[0]);

int main(int argc, char *argv[])
{
	int i;
	printf("%-16s%-16s: %s\n", "pattern", "string", "result");
	for (i = 0; i < test_tbl_cnt; i++) {
		char *result;
		char *str = test_tbl[i].str;
		char *pat = test_tbl[i].pat;
		result = (amatch(str, pat))?("matched!!"):("not matched...");
		printf("%-16s%-16s: %s\n", pat, str, result);
	}
}
